<?php
require_once "PaytmChecksum.php";
/* For Get Token */
class PHPClass
{

    function getToken()
    {
        $url = tokenRest;
        //$encPass  = 'password';
        $encPass  = $this->encryptPassword('password');
        $fields = array(
            'client_id' => 'publicclient',
            'client_secret' => '$edu#pub@21',
            'grant_type' => 'password',
            'username' => 'PUBLIC_PORTAL_USER',
            'portal_code' => 'PUBLIC_PORTAL',
            'code' => 'PUBLIC_PORTAL',
            'password' => $encPass,
        );

        $payload = http_build_query($fields);

        /*
            create the content-length header string - use `strlen` to get the length!
        */
        $contentlength = strlen($payload);

        $fields_string = "";

        //url-ify the data for the POST
        foreach ($fields as $key => $value) {
            $fields_string .= $key . '=' . $value . '&';
        }
        rtrim($fields_string, '&');

        //open connection
        $ch = curl_init();

        //set the url, number of POST vars, POST data
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_POST, $contentlength);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $payload);
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
        //execute post
        $result = curl_exec($ch);
        curl_close($ch);
        return $result;
    }

    public function encryptPassword($plaintext)
    {
        include_once('./phpseclib/Crypt/RSA.php');

        // use phpseclib\Crypt\RSA;

        $public_key = PUBLIC_KEY;
        $key = "-----BEGIN PUBLIC KEY-----\n" . wordwrap($public_key, 64, "\n", true) . "\n-----END PUBLIC KEY-----";

        $rsa = new Crypt_RSA();
        $rsa->loadKey($public_key); // public key

        $rsa->setEncryptionMode(CRYPT_RSA_ENCRYPTION_PKCS1);
        $ciphertext = $rsa->encrypt($plaintext);

        //print_r($ciphertext);

        $data = base64_encode($ciphertext);
        return $data;
    }

    function getTransactionToken($callbackUrl, $amount, $generatedOrderID, $merchantReference){

        // $generatedOrderID = "PYTM_BLINK_".time();
        $callbackUrl = domainURL.'/'.$callbackUrl;
        $paytmParams["body"] = array(
                                "requestType"   => "Payment",
                                "mid"           => PAYTM_MID,
                                "websiteName"   => PAYTM_WEBSITE,
                                "orderId"       => $generatedOrderID,
                                "callbackUrl"   => $callbackUrl,
                                "txnAmount"     => array(
                                                        "value" => $amount,
                                                        "currency" => "INR",
                                                    ),
                                "userInfo"      => array(
                                                    "custId" => $merchantReference,
                                                ),
                                "extendInfo"    => array(
                                                        "mercUnqRef"    => $merchantReference
                                                    )
                            );

        $generateSignature = PaytmChecksum::generateSignature(json_encode($paytmParams['body'], JSON_UNESCAPED_SLASHES), PAYTM_MERCHANT_KEY);

        $paytmParams["head"] = array(
                                "signature" => $generateSignature
                            );

        $url = PAYTM_ENVIRONMENT."/theia/api/v1/initiateTransaction?mid=". PAYTM_MID ."&orderId=". $generatedOrderID;
        $getcURLResponse = $this->getcURLRequest($url, $paytmParams);
        // echo "<pre>";
        //     echo $url;print_r($paytmParams);
        // print_r($getcURLResponse);
        if(!empty($getcURLResponse['body']['resultInfo']['resultStatus']) && $getcURLResponse['body']['resultInfo']['resultStatus'] == 'S'){
            $result = array('success' => true, 'orderId' => $generatedOrderID, 'txnToken' => $getcURLResponse['body']['txnToken'], 'amount' => $amount, 'message' => $getcURLResponse['body']['resultInfo']['resultMsg'], 'mercUnqRef' => $merchantReference);
        }else{
            $result = array('success' => false, 'orderId' => $generatedOrderID, 'txnToken' => '', 'amount' => $amount, 'message' => $getcURLResponse['body']['resultInfo']['resultMsg'], 'mercUnqRef' => $merchantReference);
        }
        return $result;
    
    }


    function getcURLRequest($url , $postData = array(), $headers = array("Content-Type: application/json")){

        $post_data_string = json_encode($postData, JSON_UNESCAPED_SLASHES);

        $ch = curl_init($url);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $post_data_string);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true); 
        curl_setopt($ch, CURLOPT_HTTPHEADER, array("Content-Type: application/json")); 
        $response = curl_exec($ch);
        return json_decode($response,true);
    }

    function getSiteURL(){
        $actual_link = (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] === 'on' ? "https" : "http") . "://".$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
        return str_replace('config.php', '', $actual_link);
    }
}
