<!DOCTYPE html>
<html>
<head>
   <title>Examination Payment</title>
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="css/bootstrap.min.css" crossorigin="anonymous">
	<style type="text/css">
    	.error-msg{
    		display: block;
		    margin-block-start: 1.33em;
		    margin-block-end: 1.33em;
		    margin-inline-start: 0px;
		    margin-inline-end: 0px;
		    font-weight: bold;
    	}
    	#loader{
		  position: fixed;
		  left: 0px;
		  top: 0px;
		  width: 100%;
		  height: 100%;
		  z-index: 9999;
		  background: url('image/Loader.gif') 
		              50% 50% no-repeat rgb(249,249,249);
		}
    </style>
</head>
<body style='background:#eeeeee'>
	<div id="loader"></div>
	<?php
		error_reporting(0);
		ob_start();
		header("Pragma: no-cache");
		header("Cache-Control: no-cache");
		header("Expires: 0");
		include("db_config.php");
		include("functionclass.php");
		// require_once "config.php";
		
		$ClassObject = new PHPClass();
		$token = $ClassObject->getToken();
		$token = json_decode($token);
		$authorization = "Authorization: Bearer " . $token->access_token;

		$sql = "SELECT * FROM exam_assessment_payment where id=" . $_REQUEST['id'];
		$select = mysqli_query($conn, $sql);
		$result = array();
		if (mysqli_num_rows($select) > 0) 
		{
			while ($data = mysqli_fetch_assoc($select)) 
			{
				$result[] = $data;
			}
		} 
		else 
		{
			$myObj->response_code = "110";
			$myObj->Message = "DB_ERROR";
			$myJSON = json_encode($myObj);
			echo $myJSON;
			exit;
		}
		if(empty($result[0]['order_id']))
		{
			$onlinePaymentId = $result[0]['id'];
			$examDetailsQuery = "SELECT * FROM exam_assessment_payment_detail where examAssessmentPaymentId = '".$onlinePaymentId."'";
			$examDetailsResult = mysqli_query($conn, $examDetailsQuery);
			$assesmentPaymentRows = mysqli_num_rows($examDetailsResult);
			if($assesmentPaymentRows > 0)
			{
				$orderId = $onlinePaymentId . "-" . time();
				$amount = $result[0]['totalAmount'];
				$name = $result[0]['name'];
				$email = $result[0]['email'];
				$phone = $result[0]['phoneNo'];
				$studentCode = $result[0]['studentCode'];
				$studentName = isset($result[0]['studentName']) ? $result[0]['studentName'] : '';
				$program = isset($result[0]['program']) ? $result[0]['program'] : '';
				$batch = isset($result[0]['batch']) ? $result[0]['batch'] : '';
				$feeHead = isset($result[0]['feeHead']) ? $result[0]['feeHead'] : '';

				$merchantReference = $studentCode . "_" . $name;
				
				$academyLocationId = $_REQUEST['academyLocationIds'];
				$query = "UPDATE exam_assessment_payment SET order_id='" . $orderId . "',academyLocationId='" . $academyLocationId . "'  WHERE id=" . $onlinePaymentId;
				$update = mysqli_query($conn, $query);

				$url = baseURL . paytmGatewayDetailsAPI . '?isActive=' . IS_ACTIVE . '&academyLocationIds=' . $academyLocationId;
				// exit;
				$ch = curl_init($url);
				curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "GET");
				//  curl_setopt($ch, CURLOPT_POSTFIELDS, $applicantjson); 
				curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE);
				curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
				curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
				curl_setopt($ch, CURLOPT_TIMEOUT, 120);
				curl_setopt(
					$ch,
					CURLOPT_HTTPHEADER,
					array(
						'Content-Type: application/json',
						$authorization,
					)
				);

				$resultcurl = curl_exec($ch);
				$responceERPGateway = json_decode($resultcurl);
				// echo '<pre>';print_r($responceERPGateway);die;
				$currencyCode = isset($responceERPGateway->currencyCode->currencyCode)? $responceERPGateway->currencyCode->currencyCode: 'INR';
				
				if (isset($responceERPGateway->mid) && isset($responceERPGateway->merchantKey)) 
				{
					?>
					<div class="container text-center">
				      	<div class="shadow p-3 mb-5 bg-white rounded">
				      		<h2>Paytm Checkout</h2>
				         	<h4>Make Payment</h4>
				        	<p>You are making payment of <?php echo $currencyCode.' '. $amount; ?></p>
					        <div class="btn-area">
					            <button type="button" id="blinkCheckoutPayment" name="submit" class="btn btn-primary">Pay Now</button>
					        </div>
				      	</div>
				    </div>
				    <form action="<?php echo domainURL; ?>/success_PaytmAssessmentPayment_rec.php" method="post" id="callback-form" class="d-none"> 
					</form>
					<?php
					define('PAYTM_ENVIRONMENT', $responceERPGateway->transactionURL);
					define('PAYTM_MID', $responceERPGateway->mid);
				   	define('PAYTM_MERCHANT_KEY', $responceERPGateway->merchantKey);  
				    define('PAYTM_WEBSITE', $responceERPGateway->website);
					$result = $ClassObject->getTransactionToken('success_PaytmAssessmentPayment_rec.php', $amount, $orderId, $merchantReference);
					?>
						<script type="application/javascript" crossorigin="anonymous" src="<?php echo PAYTM_ENVIRONMENT; ?>/merchantpgpui/checkoutjs/merchants/<?php echo PAYTM_MID; ?>.js"></script>
						<script>
							
							
		      				setTimeout(function() {
		      					 document.getElementById("blinkCheckoutPayment").click();
		      				},1000)
					        document.getElementById("blinkCheckoutPayment").addEventListener("click", function(){
					        		document.getElementById("loader").style.display = 'none'
					         		openBlinkCheckoutPopup('<?php echo $result['orderId']?>','<?php echo $result['txnToken']?>','<?php echo $result['amount']?>','<?php echo $result['mercUnqRef']?>');
					         	}
					         );
					         
					        function openBlinkCheckoutPopup(orderId, txnToken, amount, mercUnqRef)
					        {
					         	var config = {
					         		"root": "",
					         		"flow": "DEFAULT",
					         		"data": {
					         			"orderId": orderId, 
					         			"token": txnToken, 
					         			"tokenType": "TXN_TOKEN",
					         			"amount": amount,
					         			"mercUnqRef": mercUnqRef
									 },
									 merchant:{
												redirect: false
												},
					         		"handler": {
						         		notifyMerchant: function(eventName,data){
						         			console.log("notifyMerchant handler function called");
						         			console.log("eventName => ",eventName);
											 console.log("data => ",data);
											 if(eventName=='SESSION_EXPIRED')
											 {
												 location.reload();
											 }
						         		},
										transactionStatus:function(data){
											document.getElementById("loader").style.display = 'block';
											console.log("payment status ", data); 
											window.Paytm.CheckoutJS.close();
											var result="<h2>Response: </h2><table>";
											for (var key in data) {
												if (data.hasOwnProperty(key)) {
													result += '<input type="text" name="'+key+'" value="'+data[key]+'">'; 
												}
											}
											result += '<input type="text" name="ACADEMYLOCATIONID" value="<?php echo $academyLocationId; ?>">';
											result +="</table>";
											document.getElementById("callback-form").innerHTML=result;
											document.getElementById('callback-form').submit();
										} 
					         		}
					         	};
					         	 if(window.Paytm && window.Paytm.CheckoutJS){
					         			// initialze configuration using init method 
										 window.Paytm.CheckoutJS.init(config)
										 .then(function onSuccess() {
					         				// after successfully updating configuration, invoke checkoutjs
					         				window.Paytm.CheckoutJS.invoke();
					         			}).catch(function onError(error){
					         				console.log("error => ",error);
					         			});
					         	}
					        }
					      </script>
					<?php
				} else {
					echo '<script type="text/javascript">document.getElementById("loader").style.display = "none"; </script>';
					echo "<div class='form-group' ><div class='col-md-12 success-mqin-box' align='center' style='padding:20px;background:#fff;width:50%;margin:5px auto'><label class='error-msg'>Paytm payment gateway not configured in ERP</label></div></div>";
					exit();
				}
			}
			else
			{
				echo '<div class="col-md-12 alert alert-warning alert-dismissible fade show text-center"><h4>Unfortunately, Your transaction could not be processed. Please try again.</h4></div>';
			}
		}
		else
		{
			echo '<div class="col-md-12 alert alert-warning alert-dismissible fade show text-center"><h4>Unfortunately, Your transaction could not be processed. Please try again.</h4></div>';
		}
		echo '<script type="text/javascript">document.getElementById("loader").style.display = "none"; </script>';
	?>
</body>
</html>