<?php
include("db_config.php");
include("functionclass.php");
require_once("PaytmChecksum.php");

$dateTime = date('Y-m-d H:i:s', strtotime('-10 day'));
//**  Add Cron Log  **//

$currentDateTime = date('Y-m-d H:i:s');

$sqlPro = "INSERT INTO `cron_log` (`name`, `datetime`) VALUES ('Fee & Examp Payment', '".date('Y-m-d H:i:s')."');";
// echo $sqlPro;die();
mysqli_query($conn, $sqlPro);

/********  Start Examination Payment Process check *********/
$sqlPro = "SELECT * FROM `exam_assessment_payment` where (paymentStatus = '' or paymentStatus IS NULL or paymentStatus = 'PENDING' or paymentStatus = 'initiate' or paymentStatus = 'TXN_SUCCESS') and (receiptStatus = '' or receiptStatus IS NULL)  and academyLocationId IS NOT NULL and lastUpdate >= '".$dateTime."'";//
// echo $sqlPro;die;
$result = mysqli_query($conn, $sqlPro);

$ClassObject = new PHPClass();
$token = $ClassObject->getToken();
$token = json_decode($token);
$authorization = "Authorization: Bearer " . $token->access_token;
$merchantDetailsAccordingLocation = array();
while ($row = mysqli_fetch_assoc($result))
{
	$academicLocationId = $row['academyLocationId'];
	$orderId = $row['order_id'];
	$totalAmount = $row['totalAmount'];
	$txnId = $row['txnId'];
	$selectInstument = 0;
	$id = $row['id'];

	if($txnId)
	{
		$receiptInstrumentQuery = "SELECT * FROM receipt_payment_instrument where instrumentNo = '".$txnId."'";
	    $receiptQuery = mysqli_query($connMain, $receiptInstrumentQuery);
	    $selectInstument = mysqli_num_rows($receiptQuery);
	}

	if(!isset($merchantDetailsAccordingLocation[$academicLocationId]))
	{
		$options = array(
			'public_key' => $token->nonsec,
			'params' => 'isActive=' . IS_ACTIVE . '&academyLocationIds=' . $academicLocationId,
			'jsonData' => '',
			'access_token' => isset($token->access_token)?$token->access_token:'',
		);
		$nonce = $ClassObject->secMe($options);
		$url = baseURL . paytmGatewayDetailsAPI . '?isActive=' . IS_ACTIVE . '&academyLocationIds=' . $academicLocationId;
		// exit;
		$ch = curl_init($url);
		curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "GET");
		//  curl_setopt($ch, CURLOPT_POSTFIELDS, $applicantjson);
		curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_TIMEOUT, 120);
		curl_setopt(
			$ch,
			CURLOPT_HTTPHEADER,
			array(
				'Content-Type: application/json',
				$authorization,
				'nonce: '.$nonce
			)
		);

		$resultcurl = curl_exec($ch);

		$responceERPGateway = json_decode($resultcurl, true);
		$merchantDetailsAccordingLocation[$academicLocationId]['merchant_id'] = $responceERPGateway['mid'];
		$merchantDetailsAccordingLocation[$academicLocationId]['merchant_key'] = $responceERPGateway['merchantKey'];
		$merchantDetailsAccordingLocation[$academicLocationId]['transactionStatusURL'] = $responceERPGateway['transactionStatusURL'];
	}

	$paytmParams = array();
	$paytmParams["body"] = array(
	    "mid" => $merchantDetailsAccordingLocation[$academicLocationId]['merchant_id'],
	    "orderId" => $orderId,
	);

	$checksum = PaytmChecksum::generateSignature(json_encode($paytmParams["body"], JSON_UNESCAPED_SLASHES), $merchantDetailsAccordingLocation[$academicLocationId]['merchant_key']);
	$paytmParams["head"] = array("signature"=>$checksum);
	$post_data = json_encode($paytmParams, JSON_UNESCAPED_SLASHES);
	$url = isset($merchantDetailsAccordingLocation[$academicLocationId]['transactionStatusURL']) ? $merchantDetailsAccordingLocation[$academicLocationId]['transactionStatusURL'] : "";
	if($url)
	{

		$ch = curl_init($url);
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $post_data);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json'));
		$response = curl_exec($ch);
		$response = json_decode($response, true);
		// echo "<pre>";print_r($response);
		$transactionStatus = $response['body']['resultInfo']['resultStatus'];

		if($selectInstument == 0)
		{
			if($transactionStatus == "TXN_SUCCESS")
			{
				$orderId = $response['body']['orderId'];

				$txnId = $response['body']['txnId'];
				$query = "UPDATE exam_assessment_payment SET paymentStatus='" . $transactionStatus . "',paymentDate=curdate(), receiptStatus='', txnId='" . $txnId . "', formSubmissionStatus= 1 WHERE order_id='" . $orderId."'";
		       	$update = mysqli_query($conn, $query);
				$sqlPro = "SELECT * from exam_assessment_payment_detail where examAssessmentPaymentId=" . $id;
			    $selectPro = mysqli_query($conn, $sqlPro);
			    $dataPro = mysqli_fetch_assoc($selectPro);

			    if($dataPro)
			    {
					$examJson='{"academyLocationId":"'.$academicLocationId.'","voucherMode":"BANK","receiptType":"REGULAR","receiptNo":"","raiseBillType":"P_AND_C_FEE","receiptFor":{"id":1,"value":"STUDENT"},"currency":{"id":1},"depositedCash":null,"transactionDate":"'.date('Y-m-d').'","student":{"id":"'.$dataPro['studentId'].'"},"narration":"NA","evaluationGroupId":"'.$dataPro['evaluationGroupId'].'","evalGroupId":"'.$dataPro['evaluationGroupId'].'","admissionId":"'.$dataPro['admissionId'].'","periodId":"'.$dataPro['periodId'].'","stageName":"AssessmentGroup","feePlanType":"Exam","feePlanId":"'.$dataPro['feePlanRuleStageId'].'","status":"FULLY_PENDING","receiptPaymentInstruments":[{"paymentMode":{"id":5},"instrumentBank":{"id":1},"instrumentNo":"'.$txnId.'","instrumentDate":"'.date('Y-m-d').'","amount":"'.$totalAmount.'"}]}';				    // echo baseURL . billHeaderCreationAssessment;
					$options = array(
						'public_key' => $token->nonsec,
						'params' => '',
						'jsonData' => $examJson,
						'access_token' => isset($token->access_token)?$token->access_token:'',
					);
					$nonce = $ClassObject->secMe($options);
				    $ch1 = curl_init(baseURL . billHeaderCreationAssessment);
				    curl_setopt($ch1, CURLOPT_CUSTOMREQUEST, "POST");
				    curl_setopt($ch1, CURLOPT_POSTFIELDS, $examJson);
				    curl_setopt($ch1, CURLOPT_TIMEOUT, 120);
				    curl_setopt($ch1, CURLOPT_FOLLOWLOCATION, TRUE);
				    curl_setopt($ch1, CURLOPT_SSL_VERIFYPEER, false);
				    curl_setopt($ch1, CURLOPT_RETURNTRANSFER, TRUE);
				    curl_setopt(
				        $ch1,
				        CURLOPT_HTTPHEADER,
				        array(
				            'Content-Type: application/json', $authorization,
				            'Content-Length: ' . strlen($examJson),
							'nonce: '.$nonce
				        )
				    );

				    $resultcurl1 = curl_exec($ch1);
				    curl_close($ch1);
				    $responceERP1 = json_decode($resultcurl1);
					// echo baseURL . billHeaderCreationAssessment;
					// echo "<br>";
					// echo $examJson;
					// echo "<br>";
				    // print_r($responceERP1);
					// echo $responceERP1;
				    if ($responceERP1 != "" && $responceERP1 != 'Array' && is_int($responceERP1))
				    {
				        $query = "UPDATE exam_assessment_payment_detail SET billNo='" . $responceERP1 . "', receiptNo='" . $responceERP1 . "', billId='" . $responceERP1 . "', receiptId='" . $responceERP1 . "' WHERE examAssessmentPaymentId=" . $id;
				        $update = mysqli_query($conn, $query);

				        $query = "UPDATE exam_assessment_payment SET paymentStatus='" . $transactionStatus . "', paymentDate=curdate(), receiptStatus='" . $transactionStatus . "' WHERE id=" . $id;
				        $update = mysqli_query($conn, $query);

						$reverseQuery = "INSERT reverse_transaction_receipt (payment_type, order_id, transaction_id, date_time) VALUES('Exam payment', '".$orderId."','" .$txnId."', '".$currentDateTime."');";
						$update = mysqli_query($conn, $reverseQuery);

				    	echo "Success - ".$orderId."<br>";
				    }
				    else
				    {
				    	echo "Receipt Not Generate - ".$orderId."<br>";
				    }
			    }
			    else
			    {
			    	echo "Fail Assesment Details Not Found - ".$orderId."<br>";
			    }
			}
			else
			{
				$query = "UPDATE exam_assessment_payment SET paymentStatus='" . $transactionStatus . "', formSubmissionStatus= 1 WHERE order_id='" . $orderId."'";
		       	$update = mysqli_query($conn, $query);
				echo "Fail - ".$orderId."<br>";
			}
		}
		else
		{
			$id = $row['id'];
			$query = "UPDATE exam_assessment_payment SET paymentStatus='" . $transactionStatus . "', paymentDate=curdate(), receiptStatus='success' WHERE id=" . $id;
			$update = mysqli_query($conn, $query);
			echo 'Receipt Already Generate '.$orderId."<br>";
		}
	}
	else
	{
		echo "Status URL not found for - ".$orderId."<br>";
	}
}
/********  End Examination Payment Process check *********/
/**********  Fees payment process start **********/

$sqlPro = "SELECT * FROM `applicant_portal_erp_payment` where (paymentStatus = '' or paymentStatus IS NULL or paymentStatus = 'PENDING' or paymentStatus = 'initiate' or paymentStatus = 'TXN_SUCCESS')  and (receiptStatus = '' or receiptStatus IS NULL) and paymentOption = 'PAYTM' and academyLocationIds IS NOT NULL and lastUpdate >= '".$dateTime."'";
// echo $sqlPro;die;
$result = mysqli_query($conn, $sqlPro);
while ($row = mysqli_fetch_assoc($result))
{
	$academicLocationId = $row['academyLocationIds'];
	$orderId = $row['order_id'];
	$txnId = $row['txnId'];
	$onlinePaymentId = $row['onlinePaymentId'];
	$selectInstument = 0;
	if($txnId)
	{
		$receiptInstrumentQuery = "SELECT * FROM receipt_payment_instrument where instrumentNo = '".$txnId."'";
	    $receiptQuery = mysqli_query($connMain, $receiptInstrumentQuery);
	    $selectInstument = mysqli_num_rows($receiptQuery);
	}

	if(!isset($merchantDetailsAccordingLocation[$academicLocationId]))
	{
		$options = array(
			'public_key' => $token->nonsec,
			'params' => 'isActive=' . IS_ACTIVE . '&academyLocationIds=' . $academicLocationId,
			'jsonData' => '',
			'access_token' => isset($token->access_token)?$token->access_token:'',
		);
		$nonce = $ClassObject->secMe($options);
		$url = baseURL . paytmGatewayDetailsAPI . '?isActive=' . IS_ACTIVE . '&academyLocationIds=' . $academicLocationId;

		$ch = curl_init($url);
		curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "GET");
		curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_TIMEOUT, 120);
		curl_setopt(
			$ch,
			CURLOPT_HTTPHEADER,
			array(
				'Content-Type: application/json',
				$authorization,
				'nonce: '.$nonce
			)
		);

		$resultcurl = curl_exec($ch);
		$responceERPGateway = json_decode($resultcurl, true);
		$merchantDetailsAccordingLocation[$academicLocationId]['merchant_id'] =  $responceERPGateway['mid'];
		$merchantDetailsAccordingLocation[$academicLocationId]['merchant_key'] = $responceERPGateway['merchantKey'];
		$merchantDetailsAccordingLocation[$academicLocationId]['transactionStatusURL'] = $responceERPGateway['transactionStatusURL'];
	}
	$paytmParams = array();
	$paytmParams["body"] = array(
	    "mid" => $merchantDetailsAccordingLocation[$academicLocationId]['merchant_id'],
	    "orderId" => $orderId,
	);


	$checksum = PaytmChecksum::generateSignature(json_encode($paytmParams["body"], JSON_UNESCAPED_SLASHES), $merchantDetailsAccordingLocation[$academicLocationId]['merchant_key']);
	$paytmParams["head"] = array("signature"=>$checksum);
	$post_data = json_encode($paytmParams, JSON_UNESCAPED_SLASHES);
	$url = isset($merchantDetailsAccordingLocation[$academicLocationId]['transactionStatusURL']) ? $merchantDetailsAccordingLocation[$academicLocationId]['transactionStatusURL'] : "";
	if($url)
	{


		$ch = curl_init($url);
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $post_data);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json'));
		$response = curl_exec($ch);
		$response = json_decode($response, true);
		// echo "<pre>";print_r($response);
		$transactionStatus = $response['body']['resultInfo']['resultStatus'];
		$resultCode = $response['body']['resultInfo']['resultCode'];
		if($resultCode != 334)
		{
			if($selectInstument == 0)
			{
				if($transactionStatus == "TXN_SUCCESS")
				{
					$orderId = $response['body']['orderId'];

					$txnId = $response['body']['txnId'];
					$query = "UPDATE applicant_portal_erp_payment SET paymentStatus='" . $transactionStatus . "', receiptStatus='', txnId='" . $txnId . "', formSubmissionStatus = 1  WHERE order_id='" . $orderId . "'";
			        $update = mysqli_query($conn, $query);
			        $applicantjson = '{"id":"'.$onlinePaymentId.'","txnid":"'.$txnId.'", "status":"'.$transactionStatus.'"}';
					$options = array(
						'public_key' => $token->nonsec,
						'params' => '',
						'jsonData' => $applicantjson,
						'access_token' => isset($token->access_token)?$token->access_token:'',
					);
					$nonce = $ClassObject->secMe($options);

			        $ch = curl_init(baseURL . successRestUpdateStatus);
			        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
			        curl_setopt($ch, CURLOPT_POSTFIELDS, $applicantjson);
			        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE);
			        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
			        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
			        curl_setopt($ch, CURLOPT_TIMEOUT, 120);
			        curl_setopt(
			            $ch,
			            CURLOPT_HTTPHEADER,
			            array(
			                'Content-Type: application/json', $authorization,
			                'Content-Length: ' . strlen($applicantjson),
							'nonce: '.$nonce
			            )
			        );
			        $resultcurl = curl_exec($ch);
			        $applicantjson_save = '{"id":'.$onlinePaymentId.'}';
					$options = array(
						'public_key' => $token->nonsec,
						'params' => '',
						'jsonData' => $applicantjson_save,
						'access_token' => isset($token->access_token)?$token->access_token:'',
					);
					$nonce = $ClassObject->secMe($options);
			        $ch1 = curl_init(baseURL . successRestCreateReceipt);
			        curl_setopt($ch1, CURLOPT_CUSTOMREQUEST, "POST");
			        curl_setopt($ch1, CURLOPT_POSTFIELDS, $applicantjson_save);
			        curl_setopt($ch1, CURLOPT_FOLLOWLOCATION, TRUE);
			        curl_setopt($ch1, CURLOPT_SSL_VERIFYPEER, false);
			        curl_setopt($ch1, CURLOPT_RETURNTRANSFER, true);
			        curl_setopt($ch1, CURLOPT_TIMEOUT, 120);
			        curl_setopt(
			            $ch1,
			            CURLOPT_HTTPHEADER,
			            array(
			                'Content-Type: application/json', $authorization,
			                'Content-Length: ' . strlen($applicantjson_save),
							'nonce: '.$nonce
			            )
			        );
			        $resultcurl1 = curl_exec($ch1);
			        $responceERP1 = json_decode($resultcurl1);
			        // print_r($responceERP1);
			        if($responceERP1 == $onlinePaymentId)
			        {
			            $query = "UPDATE applicant_portal_erp_payment SET paymentStatus='" . $transactionStatus . "', receiptStatus='" . $transactionStatus . "', txnId='" . $txnId . "' WHERE onlinePaymentId=" . $onlinePaymentId;
			            $update = mysqli_query($conn, $query);
						$reverse_query = "INSERT reverse_transaction_receipt (payment_type, order_id, transaction_id, date_time) VALUES('Fees payment', '".$orderId."','" .$txnId."', '".$currentDateTime."');";
						$update = mysqli_query($conn, $reverse_query);
			        }
			        else
			        {
			        	$query = "UPDATE applicant_portal_erp_payment SET paymentStatus='" . $transactionStatus . "', receiptStatus='', txnId='" . $txnId . "' WHERE onlinePaymentId=" . $onlinePaymentId;
			            $update = mysqli_query($conn, $query);
			        }
			        echo "Success - ".$orderId."<br>";
				}
				else
				{
					$query = "UPDATE applicant_portal_erp_payment SET paymentStatus='" . $transactionStatus . "', formSubmissionStatus = 1  WHERE order_id='" . $orderId . "'";
			        $update = mysqli_query($conn, $query);
					echo "Fail - ".$orderId."<br>";
				}

			}
			else
			{
				$id = $row['id'];
				$query = "UPDATE applicant_portal_erp_payment SET paymentStatus='" . $transactionStatus . "',receiptStatus='Success' WHERE id=" . $id;
				$update = mysqli_query($conn, $query);
				echo 'Already Generate '.$orderId."<br>";
			}
		}
		else
		{
			echo "Invalid order id- ".$orderId."<br>";
		}
	}
	else
	{
		echo "Status URL not found for - ".$orderId."<br>";
	}
}
/**********  Fees payment process end **********/
/**********  Mobile App process start **********/

$logQuery = "SELECT * FROM information_schema.tables WHERE table_schema =  '".DBNAME."' AND table_name = 'mobile_app_erp_payment' LIMIT 1";
$select = mysqli_query($conn, $logQuery);
if (mysqli_num_rows($select) > 0) {
	$sqlPro = "SELECT * FROM `mobile_app_erp_payment` where (paymentStatus = '' or paymentStatus IS NULL or paymentStatus = 'PENDING' or paymentStatus = 'Initiate' or paymentStatus = 'TXN_SUCCESS')  and (receiptStatus = '' or receiptStatus IS NULL) and paymentOption = 'PayTm' and academyLocationIds IS NOT NULL and paymentDate >= '".$dateTime."'";
	// echo $sqlPro;die;
	$result = mysqli_query($conn, $sqlPro);
	while ($row = mysqli_fetch_assoc($result))
	{
		$academicLocationId = $row['academyLocationIds'];
		$orderId = $row['orderId'];
		$txnId = $row['txnId'];
		$onlinePaymentId = $row['onlinePaymentId'];
		$id = $row['id'];
		$selectInstument = 0;


		if(!isset($merchantDetailsAccordingLocation[$academicLocationId]))
		{
			$options = array(
				'public_key' => $token->nonsec,
				'params' => 'isActive=' . IS_ACTIVE . '&academyLocationIds=' . $academicLocationId,
				'jsonData' => '',
				'access_token' => isset($token->access_token)?$token->access_token:'',
			);
			$nonce = $ClassObject->secMe($options);
			$url = baseURL . paytmGatewayDetailsAPI . '?isActive=' . IS_ACTIVE . '&academyLocationIds=' . $academicLocationId;

			$ch = curl_init($url);
			curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "GET");
			curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE);
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
			curl_setopt($ch, CURLOPT_TIMEOUT, 120);
			curl_setopt(
				$ch,
				CURLOPT_HTTPHEADER,
				array(
					'Content-Type: application/json',
					$authorization,
					'nonce: '.$nonce
				)
			);

			$resultcurl = curl_exec($ch);
			$responceERPGateway = json_decode($resultcurl, true);
			$merchantDetailsAccordingLocation[$academicLocationId]['merchant_id'] =  $responceERPGateway['mid'];
			$merchantDetailsAccordingLocation[$academicLocationId]['merchant_key'] = $responceERPGateway['merchantKey'];
			$merchantDetailsAccordingLocation[$academicLocationId]['transactionStatusURL'] = $responceERPGateway['transactionStatusURL'];
		}
		$paytmParams = array();
		$paytmParams["body"] = array(
			"mid" => $merchantDetailsAccordingLocation[$academicLocationId]['merchant_id'],
			"orderId" => $orderId,
		);


		$checksum = PaytmChecksum::generateSignature(json_encode($paytmParams["body"], JSON_UNESCAPED_SLASHES), $merchantDetailsAccordingLocation[$academicLocationId]['merchant_key']);
		$paytmParams["head"] = array("signature"=>$checksum);
		$post_data = json_encode($paytmParams, JSON_UNESCAPED_SLASHES);

		$url = isset($merchantDetailsAccordingLocation[$academicLocationId]['transactionStatusURL']) ? $merchantDetailsAccordingLocation[$academicLocationId]['transactionStatusURL'] : "";
		if($url)
		{


			$ch = curl_init($url);
			curl_setopt($ch, CURLOPT_POST, 1);
			curl_setopt($ch, CURLOPT_POSTFIELDS, $post_data);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
			curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json'));
			$response = curl_exec($ch);
			$response = json_decode($response, true);
			// echo "<pre>";print_r($response);
			$resultCode = isset($response['body']['resultInfo']['resultCode']) ? $response['body']['resultInfo']['resultCode'] : '';
			if($resultCode != 334 && $resultCode != '501' && $resultCode != '')
			{
				$transactionStatus = $response['body']['resultInfo']['resultStatus'];
				$txnId = $response['body']['txnId'];
				if($txnId)
				{
					$receiptInstrumentQuery = "SELECT * FROM receipt_payment_instrument where instrumentNo = '".$txnId."'";
					$receiptQuery = mysqli_query($connMain, $receiptInstrumentQuery);
					$selectInstument = mysqli_num_rows($receiptQuery);
				}
				if($selectInstument == 0)
				{
					if($transactionStatus == "TXN_SUCCESS")
					{

						$query = "UPDATE mobile_app_erp_payment SET paymentStatus='" . $transactionStatus . "', receiptStatus='', txnId='" . $txnId . "', formSubmissionStatus = 1  WHERE id='" . $id . "'";
						$update = mysqli_query($conn, $query);
						$applicantjson = '{"id":"'.$onlinePaymentId.'","txnid":"'.$txnId.'","status":"'.$transactionStatus.'"}';
						$options = array(
							'public_key' => $token->nonsec,
							'params' => '',
							'jsonData' => $applicantjson,
							'access_token' => isset($token->access_token)?$token->access_token:'',
						);
						$nonce = $ClassObject->secMe($options);
						$ch = curl_init(baseURL . successRestUpdateStatus);
						curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
						curl_setopt($ch, CURLOPT_POSTFIELDS, $applicantjson);
						curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE);
						curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
						curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
						curl_setopt($ch, CURLOPT_TIMEOUT, 120);
						curl_setopt(
							$ch,
							CURLOPT_HTTPHEADER,
							array(
								'Content-Type: application/json', $authorization,
								'Content-Length: ' . strlen($applicantjson),
								'nonce: '.$nonce
							)
						);
						$resultcurl = curl_exec($ch);
						$applicantjson_save = '{"id":'.$onlinePaymentId.'}';
							$options = array(
								'public_key' => $token->nonsec,
								'params' => '',
								'jsonData' => $applicantjson_save,
								'access_token' => isset($token->access_token)?$token->access_token:'',
							);
							$nonce = $ClassObject->secMe($options);
						$ch1 = curl_init(baseURL . successRestCreateReceipt);
						curl_setopt($ch1, CURLOPT_CUSTOMREQUEST, "POST");
						curl_setopt($ch1, CURLOPT_POSTFIELDS, $applicantjson_save);
						curl_setopt($ch1, CURLOPT_FOLLOWLOCATION, TRUE);
						curl_setopt($ch1, CURLOPT_SSL_VERIFYPEER, false);
						curl_setopt($ch1, CURLOPT_RETURNTRANSFER, true);
						curl_setopt($ch1, CURLOPT_TIMEOUT, 120);
						curl_setopt(
							$ch1,
							CURLOPT_HTTPHEADER,
							array(
								'Content-Type: application/json', $authorization,
								'Content-Length: ' . strlen($applicantjson_save),
								'nonce: '.$nonce
							)
						);
						$resultcurl1 = curl_exec($ch1);
						$responceERP1 = json_decode($resultcurl1);
						// print_r($responceERP1);
						if($responceERP1 == $onlinePaymentId)
						{
							$query = "UPDATE mobile_app_erp_payment SET receiptStatus='" . $transactionStatus . "' WHERE id=" . $id;
							$update = mysqli_query($conn, $query);
							$reverse_query = "INSERT reverse_transaction_receipt (payment_type, order_id, transaction_id, date_time) VALUES('Mobile-APP', '".$orderId."','" .$txnId."', '".$currentDateTime."');";
							$update = mysqli_query($conn, $reverse_query);
						}
						echo "Success - ".$orderId."<br>";
					}
					else
					{
						$query = "UPDATE mobile_app_erp_payment SET paymentStatus='" . $transactionStatus . "', formSubmissionStatus = 1  WHERE id='" . $id . "'";
						$update = mysqli_query($conn, $query);
						echo "Fail - ".$orderId."<br>";
					}

				}
				else
				{
					$query = "UPDATE mobile_app_erp_payment SET paymentStatus='" . $transactionStatus . "',receiptStatus='Success', txnId='".$txnId."' WHERE id=" . $id;
					$update = mysqli_query($conn, $query);
					echo 'Already Generate '.$orderId."<br>";
				}
			}
			else
			{
				echo "Invalid order id- ".$orderId."<br>";
			}
		}
		else
		{
			echo "Status URL not found for - ".$orderId."<br>";
		}
	}
}
/**********  Mobile App process end **********/

/**********  Declaration Payment - Applicant Portal start **********/

$logQuery = "SELECT * FROM information_schema.tables WHERE table_schema =  '".DBNAME."' AND table_name = 'applicant_declaration_payment' LIMIT 1";
$select = mysqli_query($conn, $logQuery);
if (mysqli_num_rows($select) > 0) {
	$sqlPro = "SELECT * FROM `applicant_declaration_payment` where (paymentStatus = '' or paymentStatus IS NULL or paymentStatus = 'PENDING' or paymentStatus = 'Initiate' or paymentStatus = 'TXN_SUCCESS')  and (receiptStatus = '' or receiptStatus IS NULL) and paymentOption = 'PAYTM' and academyLocationIds IS NOT NULL and paymentDate >= '".$dateTime."'";
	// echo $sqlPro;die;
	$result = mysqli_query($conn, $sqlPro);
	while ($row = mysqli_fetch_assoc($result))
	{
		$academicLocationId = $row['academyLocationIds'];
		$orderId = $row['orderId'];
		$txnId = $row['txnId'];
		$onlinePaymentId = $row['onlinePaymentId'];
		$id = $row['id'];
		$selectInstument = 0;
		$applicationStatus = $row['applicationStatus'];
		$portalLinkSaveId = $row['portalLinkSaveId'];
		$applicantId = $row['applicantId'];
        $moduleId = $row['moduleId'];
        $setupId = $row['setupId'];
        $curlCheckCount = $row['curlCheckCount'];

		if(!isset($merchantDetailsAccordingLocation[$academicLocationId]))
		{
			$options = array(
				'public_key' => $token->nonsec,
				'params' => 'isActive=' . IS_ACTIVE . '&academyLocationIds=' . $academicLocationId,
				'jsonData' => '',
				'access_token' => isset($token->access_token)?$token->access_token:'',
			);
			$nonce = $ClassObject->secMe($options);
			$url = baseURL . paytmGatewayDetailsAPI . '?isActive=' . IS_ACTIVE . '&academyLocationIds=' . $academicLocationId;

			$ch = curl_init($url);
			curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "GET");
			curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE);
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
			curl_setopt($ch, CURLOPT_TIMEOUT, 120);
			curl_setopt(
				$ch,
				CURLOPT_HTTPHEADER,
				array(
					'Content-Type: application/json',
					$authorization,
					'nonce: '.$nonce
				)
			);

			$resultcurl = curl_exec($ch);
			$responceERPGateway = json_decode($resultcurl, true);
			$merchantDetailsAccordingLocation[$academicLocationId]['merchant_id'] =  $responceERPGateway['mid'];
			$merchantDetailsAccordingLocation[$academicLocationId]['merchant_key'] = $responceERPGateway['merchantKey'];
			$merchantDetailsAccordingLocation[$academicLocationId]['transactionStatusURL'] = $responceERPGateway['transactionStatusURL'];
		}
		$paytmParams = array();
		$paytmParams["body"] = array(
			"mid" => $merchantDetailsAccordingLocation[$academicLocationId]['merchant_id'],
			"orderId" => $orderId,
		);


		$checksum = PaytmChecksum::generateSignature(json_encode($paytmParams["body"], JSON_UNESCAPED_SLASHES), $merchantDetailsAccordingLocation[$academicLocationId]['merchant_key']);
		$paytmParams["head"] = array("signature"=>$checksum);
		$post_data = json_encode($paytmParams, JSON_UNESCAPED_SLASHES);

		$url = isset($merchantDetailsAccordingLocation[$academicLocationId]['transactionStatusURL']) ? $merchantDetailsAccordingLocation[$academicLocationId]['transactionStatusURL'] : "";
		$curlCheckCount++;
		if($url)
		{
			$options = array(
				'public_key' => $token->nonsec,
				'params' => '',
				'jsonData' => $post_data,
				'access_token' => isset($token->access_token)?$token->access_token:'',
			);
			$nonce = $ClassObject->secMe($options);
			$ch = curl_init($url);
			curl_setopt($ch, CURLOPT_POST, 1);
			curl_setopt($ch, CURLOPT_POSTFIELDS, $post_data);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
			curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json','nonce: '.$nonce));
			$response = curl_exec($ch);
			$response = json_decode($response, true);
			// echo "<pre>";print_r($response);
			$resultCode = isset($response['body']['resultInfo']['resultCode']) ? $response['body']['resultInfo']['resultCode'] : '';
			if($resultCode != 334 && $resultCode != '501' && $resultCode != '')
			{
				$transactionStatus = $response['body']['resultInfo']['resultStatus'];
				$txnId = $response['body']['txnId'];
				if($txnId)
				{
					$receiptInstrumentQuery = "SELECT * FROM receipt_payment_instrument where instrumentNo = '".$txnId."'";
					$receiptQuery = mysqli_query($connMain, $receiptInstrumentQuery);
					$selectInstument = mysqli_num_rows($receiptQuery);
				}
				if($selectInstument == 0)
				{
					if($transactionStatus == "TXN_SUCCESS")
					{
						if($applicationStatus != true || $applicationStatus != 'true')
						{
							$options = array(
								'public_key' => $token->nonsec,
								'params' => 'applicationId='.$applicantId.'&currentDate'.date('Y-m-d'),
								'jsonData' => '',
								'access_token' => isset($token->access_token)?$token->access_token:'',
							);
							$nonce = $ClassObject->secMe($options);
							$urlFormSubmit = baseURL.ApplicantFormSubmit.'?applicationId='.$applicantId.'&currentDate'.date('Y-m-d');
	                        $ch = curl_init($urlFormSubmit);
	                        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "GET");
	                        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE);
	                        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
	                        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	                        curl_setopt($ch, CURLOPT_TIMEOUT, 120);
	                        curl_setopt(
	                            $ch,
	                            CURLOPT_HTTPHEADER,
	                            array(
	                                'Content-Type: application/json', $authorization,
									'nonce: '.$nonce
	                            )
	                        );
	                        $formSubmitStatus = curl_exec($ch);
	                        if($formSubmitStatus == false || $formSubmitStatus == 'false')
	                        {
	                            $formSubmitStatus = 'Application END Date Pass';
	                        }
						}
						else
						{
							$formSubmitStatus = $applicationStatus;
						}

						$query = "UPDATE applicant_declaration_payment SET paymentStatus='" . $transactionStatus . "', receiptStatus='', txnId='" . $txnId . "', formSubmissionStatus = 1,applicationStatus = '".$formSubmitStatus."', curlCheckCount = '".$curlCheckCount."'  WHERE id='" . $id . "'";
						$update = mysqli_query($conn, $query);
						$applicantjson = '{"id":"'.$onlinePaymentId.'","txnid":"'.$txnId.'","status":"'.$transactionStatus.'"}';
						$options = array(
							'public_key' => $token->nonsec,
							'params' => '',
							'jsonData' => $applicantjson,
							'access_token' => isset($token->access_token)?$token->access_token:'',
						);
						$nonce = $ClassObject->secMe($options);
                        $ch = curl_init(baseURL . declarationPaymentUpdateStatus);
                        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
                        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE);
                        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);

                        curl_setopt($ch, CURLOPT_POSTFIELDS, $applicantjson);
                        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                        curl_setopt($ch, CURLOPT_TIMEOUT, 120);
                        curl_setopt(
                            $ch,
                            CURLOPT_HTTPHEADER,
                            array(
                                'Content-Type: application/json', $authorization,
                                'Content-Length: ' . strlen($applicantjson),
								'nonce: '.$nonce
                            )
                        );

                        $resultcurl = curl_exec($ch);

                        $applicantjson_save = '{"id":'.$onlinePaymentId.'}';
							$options = array(
								'public_key' => $token->nonsec,
								'params' => '',
								'jsonData' => $applicantjson_save,
								'access_token' => isset($token->access_token)?$token->access_token:'',
							);
							$nonce = $ClassObject->secMe($options);
                        $ch1 = curl_init(baseURL . declarationPaymentCreateReceipt);
                        curl_setopt($ch1, CURLOPT_CUSTOMREQUEST, "POST");
                        curl_setopt($ch1, CURLOPT_POSTFIELDS, $applicantjson_save);
                        curl_setopt($ch1, CURLOPT_FOLLOWLOCATION, TRUE);
                        curl_setopt($ch1, CURLOPT_SSL_VERIFYPEER, false);
                        curl_setopt($ch1, CURLOPT_RETURNTRANSFER, true);
                        curl_setopt($ch1, CURLOPT_TIMEOUT, 120);
                        curl_setopt(
                            $ch1,
                            CURLOPT_HTTPHEADER,
                            array(
                            'Content-Type: application/json', $authorization,
                            'Content-Length: ' . strlen($applicantjson_save),
							'nonce: '.$nonce
                            )
                        );

                        $resultcurl1 = curl_exec($ch1);
                        $responceERP1 = json_decode($resultcurl1);
                        $receiptId = $responceERP1;

						if($receiptId && is_int($receiptId) && $receiptId > 0)
						{
							$query = "UPDATE applicant_declaration_payment SET receiptStatus='" . $transactionStatus . "', receiptId = '".$receiptId."' WHERE id=" . $id;
                            $update = mysqli_query($conn, $query);
							$reverse_query = "INSERT reverse_transaction_receipt (payment_type, order_id, transaction_id, date_time) VALUES('Declaration-Payment-Appliocant-Portal', '".$orderId."','" .$txnId."', '".$currentDateTime."');";
							$update = mysqli_query($conn, $reverse_query);
							echo "Receipt Success - ".$orderId."<br>";
						}
						else
						{
							echo "Receipt Not Generated - ".$orderId."<br>";
						}
						if($moduleId && $setupId && !is_numeric($portalLinkSaveId))
                        {
                            $applicantjson = '{"application":{"id":'.$applicantId.'},"applicantPortalModules":{"id":'.$moduleId.'},"applicantPortalSetup":{"id":'.$setupId.'},"isFilled":true}';
							$options = array(
								'public_key' => $token->nonsec,
								'params' => '',
								'jsonData' => $applicantjson,
								'access_token' => isset($token->access_token)?$token->access_token:'',
							);
							$nonce = $ClassObject->secMe($options);
                            $ch = curl_init(baseURL . portalLinkSaved);
                            curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
                            curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE);
                            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);

                            curl_setopt($ch, CURLOPT_POSTFIELDS, $applicantjson);
                            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                            curl_setopt($ch, CURLOPT_TIMEOUT, 120);
                            curl_setopt(
                                $ch,
                                CURLOPT_HTTPHEADER,
                                array(
                                'Content-Type: application/json', $authorization,
                                'Content-Length: ' . strlen($applicantjson),
								'nonce: '.$nonce
                                )
                            );
                            $portalLinkSaveId = curl_exec($ch);
                            $query = "UPDATE applicant_declaration_payment SET portalLinkSaveId='" . $portalLinkSaveId . "' WHERE id=" . $id;
                            $update = mysqli_query($conn, $query);
                        }

					}
					else
					{
						$query = "UPDATE applicant_declaration_payment SET paymentStatus='" . $transactionStatus . "', formSubmissionStatus = 1, curlCheckCount = '".$curlCheckCount."'  WHERE id='" . $id . "'";
						$update = mysqli_query($conn, $query);
						echo "Fail - ".$orderId."<br>";
					}

				}
				else
				{
					$query = "UPDATE applicant_declaration_payment SET paymentStatus='" . $transactionStatus . "',receiptStatus='Already-Success', txnId='".$txnId."', curlCheckCount = '".$curlCheckCount."' WHERE id=" . $id;
					$update = mysqli_query($conn, $query);
					echo 'Already Generate '.$orderId."<br>";
				}
			}
			else
			{
				echo "Invalid order id- ".$orderId."<br>";
			}
		}
		else
		{
			echo "Status URL not found for - ".$orderId."<br>";
		}
	}
}
/**********  Declaration Payment process end **********/