-- MySQL dump 10.13  Distrib 8.0.19, for Win64 (x86_64)
--
-- Host: mysqleightdemodb.centralindia.cloudapp.azure.com    Database: gudemo_applynow
-- ------------------------------------------------------
-- Server version	8.0.21

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!50503 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `applicant_parent_gaurdian_detail`
--

DROP TABLE IF EXISTS `applicant_parent_gaurdian_detail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `applicant_parent_gaurdian_detail` (
  `id` int NOT NULL,
  `applicantId` int DEFAULT NULL,
  `firstName` varchar(85) DEFAULT NULL,
  `middleName` varchar(85) DEFAULT NULL,
  `lastName` varchar(85) DEFAULT NULL,
  `emailId` varchar(45) DEFAULT NULL,
  `mobileNo` varchar(45) DEFAULT NULL,
  `alternateNo` varchar(45) DEFAULT NULL,
  `emergencyContact` bit(1) DEFAULT NULL,
  `address` text,
  `countryId` bigint DEFAULT NULL,
  `countryName` varchar(45) DEFAULT NULL,
  `provinceId` bigint DEFAULT NULL,
  `provinceName` varchar(45) DEFAULT NULL,
  `cityId` bigint DEFAULT NULL,
  `cityName` varchar(45) DEFAULT NULL,
  `postalCode` varchar(45) DEFAULT NULL,
  `parentGaurdianIdDoc` varchar(55) DEFAULT NULL,
  `feePayer` bit(1) DEFAULT NULL,
  `feePayerIdDoc` varchar(55) DEFAULT NULL,
  `feePayerLatestPayslipDoc` varchar(55) DEFAULT NULL,
  `hasAccessLearner` bit(1) DEFAULT NULL,
  `courtOrderDoc` varchar(55) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `applicant_payment`
--

DROP TABLE IF EXISTS `applicant_payment`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `applicant_payment` (
  `id` int NOT NULL AUTO_INCREMENT,
  `salutation` varchar(45) DEFAULT NULL,
  `salutationName` varchar(50) DEFAULT NULL,
  `firstName` varchar(255) DEFAULT NULL,
  `middleName` varchar(255) DEFAULT NULL,
  `lastName` varchar(255) DEFAULT NULL,
  `printName` varchar(255) DEFAULT NULL,
  `fathersName` varchar(255) DEFAULT NULL,
  `mothersName` varchar(255) DEFAULT NULL,
  `dateOfBirth` date DEFAULT NULL,
  `gender` varchar(45) DEFAULT NULL,
  `email` varchar(255) DEFAULT NULL,
  `mobileNo` varchar(255) DEFAULT NULL,
  `status` varchar(45) DEFAULT NULL,
  `address` text,
  `countryId` bigint DEFAULT NULL,
  `countryName` varchar(255) DEFAULT NULL,
  `countryCode` varchar(255) DEFAULT NULL,
  `cityId` bigint DEFAULT NULL,
  `cityName` varchar(255) DEFAULT NULL,
  `pinCode` varchar(45) DEFAULT NULL,
  `academyLocationId` bigint DEFAULT NULL,
  `academyLocationName` varchar(255) DEFAULT NULL,
  `programGroupId` bigint DEFAULT NULL,
  `programGroupName` varchar(255) DEFAULT NULL,
  `programId` bigint DEFAULT NULL,
  `programName` varchar(255) DEFAULT NULL,
  `batchId` bigint DEFAULT NULL,
  `batchName` varchar(255) DEFAULT NULL,
  `seatTypeId` bigint DEFAULT NULL,
  `seatTypeName` varchar(255) DEFAULT NULL,
  `programBatchSeatConfigId` bigint DEFAULT NULL,
  `feeAmount` double DEFAULT NULL,
  `billNos` text,
  `receiptNos` text,
  `transactionId` varchar(255) DEFAULT NULL COMMENT ' ',
  `bankRefNum` varchar(255) DEFAULT NULL,
  `mode` varchar(255) DEFAULT NULL,
  `nameOnCard` varchar(255) DEFAULT NULL,
  `parentRegionId` bigint DEFAULT NULL,
  `countryRegionName` varchar(255) DEFAULT NULL,
  `applicationId` bigint DEFAULT NULL,
  `applicationCode` varchar(255) DEFAULT NULL,
  `applicationCreated` varchar(255) DEFAULT NULL,
  `lastUpdate` timestamp NULL DEFAULT CURRENT_TIMESTAMP,
  `profileImage` varchar(45) DEFAULT NULL,
  `parentMobileNo` varchar(45) DEFAULT NULL,
  `parentEmailId` varchar(45) DEFAULT NULL,
  `PollURL` varchar(255) DEFAULT NULL,
  `paymentOption` varchar(10) DEFAULT NULL,
  `applicationProgramId` bigint DEFAULT NULL,
  `formSubmissionStatus` tinyint(1) NOT NULL DEFAULT '0',
  `referenceId` varchar(255) DEFAULT NULL,
  `paynowReference` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `applicant_portal_erp_payment`
--

DROP TABLE IF EXISTS `applicant_portal_erp_payment`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `applicant_portal_erp_payment` (
  `id` bigint NOT NULL AUTO_INCREMENT,
  `order_id` varchar(255) DEFAULT NULL,
  `onlinePaymentId` varchar(255) DEFAULT NULL,
  `txnId` varchar(255) DEFAULT NULL,
  `paymentStatus` varchar(45) DEFAULT NULL,
  `paymentDate` datetime DEFAULT NULL,
  `receiptStatus` varchar(45) DEFAULT NULL,
  `amount` varchar(45) DEFAULT NULL,
  `name` varchar(255) DEFAULT NULL,
  `email` varchar(255) DEFAULT NULL,
  `phoneNo` varchar(45) DEFAULT NULL,
  `applicantId` varchar(255) DEFAULT NULL,
  `studentId` varchar(255) DEFAULT NULL,
  `code` varchar(255) DEFAULT NULL,
  `lastUpdate` timestamp NULL DEFAULT CURRENT_TIMESTAMP,
  `paymentOption` varchar(45) DEFAULT NULL,
  `formSubmissionStatus` int NOT NULL DEFAULT '0',
  `academyLocationIds` varchar(45) DEFAULT NULL,
  `merchantReference` varchar(100) DEFAULT NULL,
  `studentName` varchar(255) DEFAULT NULL,
  `program` varchar(255) DEFAULT NULL,
  `batch` varchar(255) DEFAULT NULL,
  `feeHead` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=181 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `cron_log`
--

DROP TABLE IF EXISTS `cron_log`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `cron_log` (
  `id` int NOT NULL,
  `name` varchar(255) NOT NULL,
  `datetime` datetime NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `exam_assessment_payment`
--

DROP TABLE IF EXISTS `exam_assessment_payment`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `exam_assessment_payment` (
  `id` bigint NOT NULL AUTO_INCREMENT,
  `order_id` varchar(100) DEFAULT NULL,
  `txnId` varchar(255) DEFAULT NULL,
  `paymentStatus` varchar(45) DEFAULT NULL,
  `paymentDate` date DEFAULT NULL,
  `receiptStatus` varchar(45) DEFAULT NULL,
  `totalAmount` double DEFAULT NULL,
  `firstName` varchar(255) DEFAULT NULL,
  `lastName` varchar(255) DEFAULT NULL,
  `email` varchar(255) DEFAULT NULL,
  `phoneNo` varchar(255) DEFAULT NULL,
  `formSubmissionStatus` tinyint(1) DEFAULT '0',
  `lastUpdate` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `studentCode` varchar(45) DEFAULT NULL,
  `studentName` varchar(255) DEFAULT NULL,
  `program` varchar(255) DEFAULT NULL,
  `batch` varchar(255) DEFAULT NULL,
  `feeHead` varchar(255) DEFAULT NULL,
  `academyLocationId` int DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=24 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `exam_assessment_payment_detail`
--

DROP TABLE IF EXISTS `exam_assessment_payment_detail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `exam_assessment_payment_detail` (
  `id` bigint NOT NULL AUTO_INCREMENT,
  `examAssessmentPaymentId` bigint DEFAULT NULL,
  `admissionId` bigint DEFAULT NULL,
  `studentId` bigint DEFAULT NULL,
  `billId` bigint DEFAULT NULL,
  `receiptId` bigint DEFAULT NULL,
  `feePlanRuleStageId` bigint DEFAULT NULL,
  `amount` double DEFAULT NULL,
  `periodId` bigint DEFAULT NULL,
  `voucherMode` bigint DEFAULT NULL,
  `evaluationGroupId` bigint DEFAULT NULL,
  `currency` bigint DEFAULT NULL,
  `feePlanType` bigint DEFAULT NULL,
  `stageName` bigint DEFAULT NULL,
  `appliedDate` date DEFAULT NULL,
  `lastUpdate` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `courseName` varchar(255) DEFAULT NULL,
  `eventName` varchar(255) DEFAULT NULL,
  `billNo` varchar(255) DEFAULT NULL,
  `receiptNo` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `exam_assessment_payment_detail_FK_idx` (`examAssessmentPaymentId`),
  CONSTRAINT `exam_assessment_payment_detail_FK` FOREIGN KEY (`examAssessmentPaymentId`) REFERENCES `exam_assessment_payment` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=41 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `exam_reval_payment`
--

DROP TABLE IF EXISTS `exam_reval_payment`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `exam_reval_payment` (
  `id` bigint NOT NULL AUTO_INCREMENT,
  `txnId` varchar(255) DEFAULT NULL,
  `orderId` varchar(255) DEFAULT NULL,
  `merchantReference` varchar(255) DEFAULT NULL,
  `academyLocationIds` varchar(255) DEFAULT NULL,
  `paymentStatus` varchar(45) DEFAULT NULL,
  `paymentDate` datetime DEFAULT NULL,
  `receiptStatus` varchar(45) DEFAULT NULL,
  `totalAmount` double DEFAULT NULL,
  `firstName` varchar(255) DEFAULT NULL,
  `lastName` varchar(255) DEFAULT NULL,
  `email` varchar(255) DEFAULT NULL,
  `phoneNo` varchar(255) DEFAULT NULL,
  `formSubmissionStatus` tinyint(1) DEFAULT '0',
  `lastUpdate` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `studentCode` varchar(45) DEFAULT NULL,
  `paymentOption` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=40 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `exam_reval_payment_detail`
--

DROP TABLE IF EXISTS `exam_reval_payment_detail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `exam_reval_payment_detail` (
  `id` bigint NOT NULL AUTO_INCREMENT,
  `examRevalPaymentId` bigint DEFAULT NULL,
  `admissionId` bigint DEFAULT NULL,
  `studentId` bigint DEFAULT NULL,
  `billId` bigint DEFAULT NULL,
  `receiptId` bigint DEFAULT NULL,
  `feePlanRuleStageId` bigint DEFAULT NULL,
  `amount` double DEFAULT NULL,
  `examRevalRuleMappingId` bigint DEFAULT NULL,
  `examinationResultId` bigint DEFAULT NULL,
  `courseVariantId` bigint DEFAULT NULL,
  `periodId` bigint DEFAULT NULL,
  `eventId` bigint DEFAULT NULL,
  `revaluationType` varchar(30) DEFAULT NULL,
  `appliedDate` date DEFAULT NULL,
  `previousMarks` double DEFAULT NULL,
  `previousGrade` varchar(30) DEFAULT NULL,
  `previousGradePoint` double DEFAULT NULL,
  `previousResultStatus` varchar(60) DEFAULT NULL,
  `lastUpdate` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `courseName` varchar(255) DEFAULT NULL,
  `eventName` varchar(255) DEFAULT NULL,
  `billNo` varchar(255) DEFAULT NULL,
  `receiptNo` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `exam_reval_payment_detail_examRevalPaymentId` (`examRevalPaymentId`)
) ENGINE=InnoDB AUTO_INCREMENT=34 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `mobile_app_erp_payment`
--

DROP TABLE IF EXISTS `mobile_app_erp_payment`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mobile_app_erp_payment` (
  `id` bigint NOT NULL AUTO_INCREMENT,
  `orderId` varchar(255) DEFAULT NULL,
  `onlinePaymentId` varchar(255) DEFAULT NULL,
  `txnId` varchar(255) DEFAULT NULL,
  `paymentStatus` varchar(45) DEFAULT NULL,
  `paymentDate` datetime DEFAULT NULL,
  `receiptStatus` varchar(45) DEFAULT NULL,
  `amount` varchar(45) DEFAULT NULL,
  `name` varchar(255) DEFAULT NULL,
  `email` varchar(255) DEFAULT NULL,
  `phoneNo` varchar(45) DEFAULT NULL,
  `applicantId` varchar(255) DEFAULT NULL,
  `studentId` varchar(255) DEFAULT NULL,
  `code` varchar(255) DEFAULT NULL,
  `paymentOption` varchar(45) DEFAULT NULL,
  `formSubmissionStatus` int NOT NULL DEFAULT '0',
  `academyLocationIds` varchar(45) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=21 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `payment_log`
--

DROP TABLE IF EXISTS `payment_log`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `payment_log` (
  `id` int NOT NULL AUTO_INCREMENT,
  `txn_id` varchar(255) NOT NULL,
  `responce` longtext NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=59 DEFAULT CHARSET=utf8mb4;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `reverse_transaction_receipt`
--

DROP TABLE IF EXISTS `reverse_transaction_receipt`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `reverse_transaction_receipt` (
  `id` int NOT NULL AUTO_INCREMENT,
  `payment_type` varchar(255) DEFAULT NULL,
  `order_id` varchar(255) DEFAULT NULL,
  `transaction_id` varchar(255) DEFAULT NULL,
  `date_time` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;
/*!40101 SET character_set_client = @saved_cs_client */;

CREATE TABLE `applicant_declaration_payment` (
  `id` bigint(20) NOT NULL,
  `onlinePaymentId` varchar(255) DEFAULT NULL,
  `txnId` varchar(255) DEFAULT NULL,
  `orderId` varchar(255) DEFAULT NULL,
  `receiptId` varchar(255) DEFAULT NULL,
  `paymentStatus` varchar(45) DEFAULT NULL,
  `paymentDate` datetime DEFAULT NULL,
  `receiptStatus` varchar(45) DEFAULT NULL,
  `amount` varchar(45) DEFAULT NULL,
  `currency` varchar(100) DEFAULT NULL,
  `name` varchar(255) DEFAULT NULL,
  `email` varchar(255) DEFAULT NULL,
  `phoneNo` varchar(235) DEFAULT NULL,
  `paymentOption` varchar(235) DEFAULT NULL,
  `applicantId` varchar(255) DEFAULT NULL,
  `code` varchar(255) DEFAULT NULL,
  `lastUpdate` timestamp NULL DEFAULT current_timestamp(),
  `formSubmissionStatus` int(11) NOT NULL DEFAULT 0,
  `academyLocationIds` varchar(45) DEFAULT NULL,
  `merchantReference` varchar(100) DEFAULT NULL,
  `applicationStatus` varchar(255) DEFAULT NULL,
  `moduleId` int(11) DEFAULT NULL,
  `setupId` int(11) DEFAULT NULL,
  `curlCheckCount` int(11) NOT NULL DEFAULT 0,
  `portalLinkSaveId` varchar(255) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

--
-- Indexes for table `applicant_declaration_payment`
--
ALTER TABLE `applicant_declaration_payment`
  ADD PRIMARY KEY (`id`);

  --
-- AUTO_INCREMENT for table `applicant_declaration_payment`
--
ALTER TABLE `applicant_declaration_payment`
  MODIFY `id` bigint(20) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=1;
--
-- Dumping events for database 'gudemo_applynow'
--

--
-- Dumping routines for database 'gudemo_applynow'
--
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2022-10-13 11:04:37
