<!DOCTYPE html>
<html>
<head>
   <title>Online Payment</title>
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="css/bootstrap.min.css" crossorigin="anonymous">
  <style type="text/css">
    .footer-main{
         position: absolute;
         bottom: 0;
         text-align: center;
         background: #dddddd42;
      }
      .error-msg{
        display: block;
        margin-block-start: 1.33em;
        margin-block-end: 1.33em;
        margin-inline-start: 0px;
        margin-inline-end: 0px;
        font-weight: bold;
      }
      #loader{
      position: fixed;
      left: 0px;
      top: 0px;
      width: 100%;
      height: 100%;
      z-index: 9999;
      background: url('image/Loader.gif')
                  50% 50% no-repeat rgb(249,249,249);
    }
    </style>
</head>
<body style='background:#eeeeee'>
  <div id="loader"></div>
    <?php
        error_reporting(E_ALL);
        include("functionclass.php");
        include("db_config.php");
        $ClassObject = new PHPClass();

        $token = $ClassObject->getToken();
        $token = json_decode($token);
        $authorization = "Authorization: Bearer " . $token->access_token;

        $sql = "SELECT * FROM applicant_declaration_payment where id=" . $_REQUEST['id'];
        $select = mysqli_query($conn, $sql);
        $result = mysqli_fetch_assoc($select);
        if($result)
        {
            if($result['orderId'])
            {
                echo '<div class="col-md-12 text-center alert alert-warning"><h4>Please try again later because Order ID already generated for this order.</h4></div>';
            }
            else
            {
                $paymentId = $_REQUEST['id'];
                $onlinePaymentId = $result['onlinePaymentId'];
                $orderId = $paymentId . "-" . time();

                $query = "SELECT * FROM applicant_declaration_payment where orderId = '".$orderId."'";
                $checkOrderInfo = mysqli_query($conn, $query);
                $orderIdCount = mysqli_num_rows($checkOrderInfo);
                if($orderIdCount == 0)
                {
                    $amount = $result['amount'];
                    $name = $result['name'];
                    $email = $result['email'];
                    $phone = $result['phoneNo'];
                    $applicantCode = $result['code'];

                    $merchantReference = $applicantCode . "_" . $name;
                    $applicantId = $result['applicantId'];
                    $academyLocationId = $_REQUEST['academyLocationIds'];
                    $options = array(
                        'public_key' => $token->nonsec,
                        'params' => 'isActive=' . IS_ACTIVE . '&academyLocationIds=' . $academyLocationId,
                        'jsonData' => '',
                        'access_token' => isset($token->access_token)?$token->access_token:'',
                    );
                    $nonce = $ClassObject->secMe($options);
                    $url = baseURL . paytmGatewayDetailsAPI . '?isActive=' . IS_ACTIVE . '&academyLocationIds=' . $academyLocationId;
                    $ch = curl_init($url);
                    curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "GET");
                    curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE);
                    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
                    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                    curl_setopt($ch, CURLOPT_TIMEOUT, 120);
                    curl_setopt(
                        $ch,
                        CURLOPT_HTTPHEADER,
                        array(
                            'Content-Type: application/json',
                            $authorization,
                            'nonce: '.$nonce
                        )
                    );

                    $resultcurl = curl_exec($ch);
                    $responceERPGateway = json_decode($resultcurl);

                    if (isset($responceERPGateway->mid) && isset($responceERPGateway->merchantKey))
                    {
                        $currencyCode = isset($responceERPGateway->currencyCode->currencyCode) ? $responceERPGateway->currencyCode->currencyCode: 'INR';
                        $query = "UPDATE applicant_declaration_payment SET paymentOption = 'PAYTM', orderId = '" . $orderId . "', merchantReference =  '" . $merchantReference . "', academyLocationIds = '".$academyLocationId."', currency = '".$currencyCode."' WHERE id='" . $paymentId . "'";
                        $update = mysqli_query($conn, $query);
                        ?>
                        <form action="<?php echo domainURL; ?>/successDeclarationResponse.php" method="post" id="callback-form" class="d-none">
                        </form>
                        <div class="container text-center">
                            <div class="shadow p-3 mb-5 bg-white rounded">
                                <h2>Paytm Checkout</h2>
                                <h4>Make Payment</h4>
                                <p>You are making payment of <?php echo $currencyCode.' '. $amount; ?></p>
                                <div class="btn-area">
                                    <button type="button" id="blinkCheckoutPayment" name="submit" class="btn btn-primary">Pay Now</button>
                                </div>
                            </div>
                        </div>
                        <?php
                        define('PAYTM_ENVIRONMENT', $responceERPGateway->transactionURL);
                        define('PAYTM_MID', $responceERPGateway->mid);
                        define('PAYTM_MERCHANT_KEY', $responceERPGateway->merchantKey);
                        define('PAYTM_WEBSITE', $responceERPGateway->website);
                        $result = $ClassObject->getTransactionToken('successDeclarationResponse.php', $amount, $orderId, $merchantReference);
                        // print_r($result);//die;
                        ?>
                            <script type="application/javascript" crossorigin="anonymous" src="<?php echo PAYTM_ENVIRONMENT; ?>/merchantpgpui/checkoutjs/merchants/<?php echo PAYTM_MID; ?>.js"></script>
                            <script>
                                setTimeout(function() {
                                     document.getElementById("blinkCheckoutPayment").click();
                                },1000)
                                document.getElementById("blinkCheckoutPayment").addEventListener("click", function(){
                                        document.getElementById("loader").style.display = 'none'
                                        openBlinkCheckoutPopup('<?php echo $result['orderId']?>','<?php echo $result['txnToken']?>','<?php echo $result['amount']?>','<?php echo $result['mercUnqRef']?>');
                                    }
                                 );

                                function openBlinkCheckoutPopup(orderId, txnToken, amount, mercUnqRef)
                                {
                                    var config = {
                                        "root": "",
                                        "flow": "DEFAULT",
                                        "data": {
                                            "orderId": orderId,
                                            "token": txnToken,
                                            "tokenType": "TXN_TOKEN",
                                            "amount": amount ,
                                            "mercUnqRef": mercUnqRef
                                         },
                                         merchant:{
                                                    redirect: false
                                                    },
                                        "handler": {
                                            notifyMerchant: function(eventName,data){
                                                console.log("notifyMerchant handler function called");
                                                console.log("eventName => ",eventName);
                                                 console.log("data => ",data);
                                                 if(eventName=='SESSION_EXPIRED')
                                                 {
                                                     location.reload();
                                                 }
                                            },
                                            transactionStatus:function(data){
                                                document.getElementById("loader").style.display = 'block';
                                                console.log("payment status ", data);
                                                window.Paytm.CheckoutJS.close();
                                                var result="<h2>Response: </h2><table>";
                                                for (var key in data) {
                                                    if (data.hasOwnProperty(key)) {
                                                        result += '<input type="text" name="'+key+'" value="'+data[key]+'">';
                                                    }
                                                }
                                                result += '<input type="text" name="ACADEMYLOCATIONID" value="<?php echo $academyLocationId; ?>">';
                                                result +="</table>";
                                                document.getElementById("callback-form").innerHTML=result;
                                                document.getElementById('callback-form').submit();
                                            }
                                        }
                                    };
                                    if(window.Paytm && window.Paytm.CheckoutJS){
                                            // initialze configuration using init method
                                             window.Paytm.CheckoutJS.init(config)
                                             .then(function onSuccess() {
                                                // after successfully updating configuration, invoke checkoutjs
                                                window.Paytm.CheckoutJS.invoke();
                                            }).catch(function onError(error){
                                                console.log("error => ",error);
                                            });
                                    }
                                }
                              </script>
                            <?php
                    }
                    else
                    {
                        echo '<div class="col-md-12 text-center alert alert-warning">
                                <h4>Unfortunately, Your transaction could not be processed. Please contact to Admin.</h4>
                            </div>';
                    }
                }
                else
                {
                    echo '<div class="col-md-12 text-center alert alert-warning">
                            <h4>Please try again later because same Order ID is already generated on Payment Gateway.</h4>
                        </div>';
                }

            }
        }
        else
        {
            echo '<div class="col-md-12 text-center alert alert-warning">
                        <h4>Unfortunately, Your transaction could not be processed. Please try again.</h4>
                    </div>';
        }

    ?>
     <script type="text/javascript">
        setTimeout(()=> {
            document.getElementById("loader").style.display = 'none';
         },2000)
    </script>
</body>
</html>