-- phpMyAdmin SQL Dump
-- version 5.1.1
-- https://www.phpmyadmin.net/
--
-- Host: 127.0.0.1
-- Generation Time: Dec 08, 2021 at 10:15 AM
-- Server version: 10.4.21-MariaDB
-- PHP Version: 7.4.23

SET SQL_MODE = "NO_AUTO_VALUE_ON_ZERO";
START TRANSACTION;
SET time_zone = "+00:00";


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8mb4 */;

--
-- Database: `gudemo_applynow`
--

-- --------------------------------------------------------

--
-- Table structure for table `applicant_parent_gaurdian_detail`
--

CREATE TABLE `applicant_parent_gaurdian_detail` (
  `id` int(11) NOT NULL,
  `applicantId` int(11) DEFAULT NULL,
  `firstName` varchar(85) DEFAULT NULL,
  `middleName` varchar(85) DEFAULT NULL,
  `lastName` varchar(85) DEFAULT NULL,
  `emailId` varchar(45) DEFAULT NULL,
  `mobileNo` varchar(45) DEFAULT NULL,
  `alternateNo` varchar(45) DEFAULT NULL,
  `emergencyContact` bit(1) DEFAULT NULL,
  `address` text DEFAULT NULL,
  `countryId` bigint(20) DEFAULT NULL,
  `countryName` varchar(45) DEFAULT NULL,
  `provinceId` bigint(20) DEFAULT NULL,
  `provinceName` varchar(45) DEFAULT NULL,
  `cityId` bigint(20) DEFAULT NULL,
  `cityName` varchar(45) DEFAULT NULL,
  `postalCode` varchar(45) DEFAULT NULL,
  `parentGaurdianIdDoc` varchar(55) DEFAULT NULL,
  `feePayer` bit(1) DEFAULT NULL,
  `feePayerIdDoc` varchar(55) DEFAULT NULL,
  `feePayerLatestPayslipDoc` varchar(55) DEFAULT NULL,
  `hasAccessLearner` bit(1) DEFAULT NULL,
  `courtOrderDoc` varchar(55) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `applicant_payment`
--

CREATE TABLE `applicant_payment` (
  `id` int(11) NOT NULL,
  `salutation` varchar(45) DEFAULT NULL,
  `salutationName` varchar(50) DEFAULT NULL,
  `firstName` varchar(255) DEFAULT NULL,
  `middleName` varchar(255) DEFAULT NULL,
  `lastName` varchar(255) DEFAULT NULL,
  `printName` varchar(255) DEFAULT NULL,
  `fathersName` varchar(255) DEFAULT NULL,
  `mothersName` varchar(255) DEFAULT NULL,
  `dateOfBirth` date DEFAULT NULL,
  `gender` varchar(45) DEFAULT NULL,
  `email` varchar(255) DEFAULT NULL,
  `mobileNo` varchar(255) DEFAULT NULL,
  `status` varchar(45) DEFAULT NULL,
  `address` text DEFAULT NULL,
  `countryId` bigint(20) DEFAULT NULL,
  `countryName` varchar(255) DEFAULT NULL,
  `countryCode` varchar(255) DEFAULT NULL,
  `cityId` bigint(20) DEFAULT NULL,
  `cityName` varchar(255) DEFAULT NULL,
  `pinCode` varchar(45) DEFAULT NULL,
  `academyLocationId` bigint(20) DEFAULT NULL,
  `academyLocationName` varchar(255) DEFAULT NULL,
  `programGroupId` bigint(20) DEFAULT NULL,
  `programGroupName` varchar(255) DEFAULT NULL,
  `programId` bigint(20) DEFAULT NULL,
  `programName` varchar(255) DEFAULT NULL,
  `batchId` bigint(20) DEFAULT NULL,
  `batchName` varchar(255) DEFAULT NULL,
  `seatTypeId` bigint(20) DEFAULT NULL,
  `seatTypeName` varchar(255) DEFAULT NULL,
  `programBatchSeatConfigId` bigint(20) DEFAULT NULL,
  `feeAmount` double DEFAULT NULL,
  `billNos` text DEFAULT NULL,
  `receiptNos` text DEFAULT NULL,
  `transactionId` varchar(255) DEFAULT NULL COMMENT ' ',
  `bankRefNum` varchar(255) DEFAULT NULL,
  `mode` varchar(255) DEFAULT NULL,
  `nameOnCard` varchar(255) DEFAULT NULL,
  `parentRegionId` bigint(20) DEFAULT NULL,
  `countryRegionName` varchar(255) DEFAULT NULL,
  `applicationId` bigint(20) DEFAULT NULL,
  `applicationCode` varchar(255) DEFAULT NULL,
  `applicationCreated` varchar(255) DEFAULT NULL,
  `lastUpdate` timestamp NULL DEFAULT current_timestamp(),
  `profileImage` varchar(45) DEFAULT NULL,
  `parentMobileNo` varchar(45) DEFAULT NULL,
  `parentEmailId` varchar(45) DEFAULT NULL,
  `PollURL` varchar(255) DEFAULT NULL,
  `paymentOption` varchar(10) DEFAULT NULL,
  `applicationProgramId` bigint(20) DEFAULT NULL,
  `formSubmissionStatus` tinyint(1) NOT NULL DEFAULT 0,
  `referenceId` varchar(255) DEFAULT NULL,
  `paynowReference` varchar(255) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `applicant_portal_erp_payment`
--

CREATE TABLE `applicant_portal_erp_payment` (
  `id` bigint(20) NOT NULL,
  `order_id` varchar(255) DEFAULT NULL,
  `onlinePaymentId` varchar(255) DEFAULT NULL,
  `txnId` varchar(255) DEFAULT NULL,
  `paymentStatus` varchar(45) DEFAULT NULL,
  `paymentDate` datetime DEFAULT NULL,
  `receiptStatus` varchar(45) DEFAULT NULL,
  `amount` varchar(45) DEFAULT NULL,
  `name` varchar(255) DEFAULT NULL,
  `email` varchar(255) DEFAULT NULL,
  `phoneNo` varchar(45) DEFAULT NULL,
  `applicantId` varchar(255) DEFAULT NULL,
  `studentId` varchar(255) DEFAULT NULL,
  `code` varchar(255) DEFAULT NULL,
  `lastUpdate` timestamp NULL DEFAULT current_timestamp(),
  `paymentOption` varchar(45) DEFAULT NULL,
  `formSubmissionStatus` int(11) NOT NULL DEFAULT 0,
  `academyLocationIds` varchar(45) DEFAULT NULL,
  `merchantReference` varchar(100) DEFAULT NULL,
  `studentName` varchar(255) DEFAULT NULL,
  `program` varchar(255) DEFAULT NULL,
  `batch` varchar(255) DEFAULT NULL,
  `feeHead` varchar(255) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `cron_log`
--

CREATE TABLE `cron_log` (
  `id` int(11) NOT NULL,
  `name` varchar(255) NOT NULL,
  `datetime` datetime NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- --------------------------------------------------------

--
-- Table structure for table `exam_assessment_payment`
--

CREATE TABLE `exam_assessment_payment` (
  `id` bigint(20) NOT NULL,
  `order_id` varchar(100) DEFAULT NULL,
  `txnId` varchar(255) DEFAULT NULL,
  `paymentStatus` varchar(45) DEFAULT NULL,
  `paymentDate` date DEFAULT NULL,
  `receiptStatus` varchar(45) DEFAULT NULL,
  `totalAmount` double DEFAULT NULL,
  `firstName` varchar(255) DEFAULT NULL,
  `lastName` varchar(255) DEFAULT NULL,
  `email` varchar(255) DEFAULT NULL,
  `phoneNo` varchar(255) DEFAULT NULL,
  `formSubmissionStatus` tinyint(1) DEFAULT 0,
  `lastUpdate` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  `studentCode` varchar(45) DEFAULT NULL,
  `studentName` varchar(255) DEFAULT NULL,
  `program` varchar(255) DEFAULT NULL,
  `batch` varchar(255) DEFAULT NULL,
  `feeHead` varchar(255) DEFAULT NULL,
  `academyLocationId` int(11) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `exam_assessment_payment_detail`
--

CREATE TABLE `exam_assessment_payment_detail` (
  `id` bigint(20) NOT NULL,
  `examAssessmentPaymentId` bigint(20) DEFAULT NULL,
  `admissionId` bigint(20) DEFAULT NULL,
  `studentId` bigint(20) DEFAULT NULL,
  `billId` bigint(20) DEFAULT NULL,
  `receiptId` bigint(20) DEFAULT NULL,
  `feePlanRuleStageId` bigint(20) DEFAULT NULL,
  `amount` double DEFAULT NULL,
  `periodId` bigint(20) DEFAULT NULL,
  `voucherMode` bigint(20) DEFAULT NULL,
  `evaluationGroupId` bigint(20) DEFAULT NULL,
  `currency` bigint(20) DEFAULT NULL,
  `feePlanType` bigint(20) DEFAULT NULL,
  `stageName` bigint(20) DEFAULT NULL,
  `appliedDate` date DEFAULT NULL,
  `lastUpdate` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  `courseName` varchar(255) DEFAULT NULL,
  `eventName` varchar(255) DEFAULT NULL,
  `billNo` varchar(255) DEFAULT NULL,
  `receiptNo` varchar(255) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `exam_reval_payment`
--

CREATE TABLE `exam_reval_payment` (
  `id` bigint(20) NOT NULL,
  `txnId` varchar(255) DEFAULT NULL,
  `orderId` varchar(255) DEFAULT NULL,
  `merchantReference` varchar(255) DEFAULT NULL,
  `academyLocationIds` varchar(255) DEFAULT NULL,
  `paymentStatus` varchar(45) DEFAULT NULL,
  `paymentDate` datetime DEFAULT NULL,
  `receiptStatus` varchar(45) DEFAULT NULL,
  `totalAmount` double DEFAULT NULL,
  `firstName` varchar(255) DEFAULT NULL,
  `lastName` varchar(255) DEFAULT NULL,
  `email` varchar(255) DEFAULT NULL,
  `phoneNo` varchar(255) DEFAULT NULL,
  `formSubmissionStatus` tinyint(1) DEFAULT 0,
  `lastUpdate` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  `studentCode` varchar(45) DEFAULT NULL,
  `paymentOption` varchar(255) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `exam_reval_payment_detail`
--

CREATE TABLE `exam_reval_payment_detail` (
  `id` bigint(20) NOT NULL,
  `examRevalPaymentId` bigint(20) DEFAULT NULL,
  `admissionId` bigint(20) DEFAULT NULL,
  `studentId` bigint(20) DEFAULT NULL,
  `billId` bigint(20) DEFAULT NULL,
  `receiptId` bigint(20) DEFAULT NULL,
  `feePlanRuleStageId` bigint(20) DEFAULT NULL,
  `amount` double DEFAULT NULL,
  `examRevalRuleMappingId` bigint(20) DEFAULT NULL,
  `examinationResultId` bigint(20) DEFAULT NULL,
  `courseVariantId` bigint(20) DEFAULT NULL,
  `periodId` bigint(20) DEFAULT NULL,
  `eventId` bigint(20) DEFAULT NULL,
  `revaluationType` varchar(30) DEFAULT NULL,
  `appliedDate` date DEFAULT NULL,
  `previousMarks` double DEFAULT NULL,
  `previousGrade` varchar(30) DEFAULT NULL,
  `previousGradePoint` double DEFAULT NULL,
  `previousResultStatus` varchar(60) DEFAULT NULL,
  `lastUpdate` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  `courseName` varchar(255) DEFAULT NULL,
  `eventName` varchar(255) DEFAULT NULL,
  `billNo` varchar(255) DEFAULT NULL,
  `receiptNo` varchar(255) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `mobile_app_erp_payment`
--

CREATE TABLE `mobile_app_erp_payment` (
  `id` bigint(20) NOT NULL,
  `orderId` varchar(255) DEFAULT NULL,
  `onlinePaymentId` varchar(255) DEFAULT NULL,
  `txnId` varchar(255) DEFAULT NULL,
  `paymentStatus` varchar(45) DEFAULT NULL,
  `paymentDate` datetime DEFAULT NULL,
  `receiptStatus` varchar(45) DEFAULT NULL,
  `amount` varchar(45) DEFAULT NULL,
  `name` varchar(255) DEFAULT NULL,
  `email` varchar(255) DEFAULT NULL,
  `phoneNo` varchar(45) DEFAULT NULL,
  `applicantId` varchar(255) DEFAULT NULL,
  `studentId` varchar(255) DEFAULT NULL,
  `code` varchar(255) DEFAULT NULL,
  `paymentOption` varchar(45) DEFAULT NULL,
  `formSubmissionStatus` int(11) NOT NULL DEFAULT 0,
  `academyLocationIds` varchar(45) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `reverse_transaction_receipt`
--

CREATE TABLE `reverse_transaction_receipt` (
  `id` int(11) NOT NULL,
  `payment_type` varchar(255) DEFAULT NULL,
  `order_id` varchar(255) DEFAULT NULL,
  `transaction_id` varchar(255) DEFAULT NULL,
  `date_time` timestamp NULL DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

--
-- Indexes for dumped tables
--

--
-- Indexes for table `applicant_parent_gaurdian_detail`
--
ALTER TABLE `applicant_parent_gaurdian_detail`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `applicant_payment`
--
ALTER TABLE `applicant_payment`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `applicant_portal_erp_payment`
--
ALTER TABLE `applicant_portal_erp_payment`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `cron_log`
--
ALTER TABLE `cron_log`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `exam_assessment_payment`
--
ALTER TABLE `exam_assessment_payment`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `exam_assessment_payment_detail`
--
ALTER TABLE `exam_assessment_payment_detail`
  ADD PRIMARY KEY (`id`),
  ADD KEY `exam_assessment_payment_detail_FK_idx` (`examAssessmentPaymentId`);

--
-- Indexes for table `exam_reval_payment`
--
ALTER TABLE `exam_reval_payment`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `exam_reval_payment_detail`
--
ALTER TABLE `exam_reval_payment_detail`
  ADD PRIMARY KEY (`id`),
  ADD KEY `exam_reval_payment_detail_examRevalPaymentId` (`examRevalPaymentId`);

--
-- Indexes for table `mobile_app_erp_payment`
--
ALTER TABLE `mobile_app_erp_payment`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `reverse_transaction_receipt`
--
ALTER TABLE `reverse_transaction_receipt`
  ADD PRIMARY KEY (`id`);

--
-- AUTO_INCREMENT for dumped tables
--

--
-- AUTO_INCREMENT for table `applicant_payment`
--
ALTER TABLE `applicant_payment`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `applicant_portal_erp_payment`
--
ALTER TABLE `applicant_portal_erp_payment`
  MODIFY `id` bigint(20) NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `cron_log`
--
ALTER TABLE `cron_log`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `exam_assessment_payment`
--
ALTER TABLE `exam_assessment_payment`
  MODIFY `id` bigint(20) NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `exam_assessment_payment_detail`
--
ALTER TABLE `exam_assessment_payment_detail`
  MODIFY `id` bigint(20) NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `exam_reval_payment`
--
ALTER TABLE `exam_reval_payment`
  MODIFY `id` bigint(20) NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `exam_reval_payment_detail`
--
ALTER TABLE `exam_reval_payment_detail`
  MODIFY `id` bigint(20) NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `mobile_app_erp_payment`
--
ALTER TABLE `mobile_app_erp_payment`
  MODIFY `id` bigint(20) NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `reverse_transaction_receipt`
--
ALTER TABLE `reverse_transaction_receipt`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

--
-- Constraints for dumped tables
--

--
-- Constraints for table `exam_assessment_payment_detail`
--
ALTER TABLE `exam_assessment_payment_detail`
  ADD CONSTRAINT `exam_assessment_payment_detail_FK` FOREIGN KEY (`examAssessmentPaymentId`) REFERENCES `exam_assessment_payment` (`id`);
COMMIT;

/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
