<!DOCTYPE html>
<html>
    <head>
        <title>Paytm Payment Gateway</title>
        <link rel="stylesheet" href="css/bootstrap.min.css" crossorigin="anonymous">
        <style type="text/css">
            .footer-main{
                position: absolute;
                bottom: 0;
                text-align: center;
                background: #dddddd42;
            }
            #loader{
              position: fixed;
              left: 0px;
              top: 0px;
              width: 100%;
              height: 100%;
              z-index: 9999;
              background: url('image/Loader.gif') 
                          50% 50% no-repeat rgb(249,249,249);
            }
        </style>
    </head>
    <body>
        <div id="loader"></div>
        <?php
            require_once "PaytmChecksum.php";
            // echo "<pre>";print_r($_POST);die;
            error_reporting(E_ALL);
            include('Logger.php');
            Logger::notice("Success-Assessment-Fee");
            Logger::info(serialize($_POST));
            ob_start();
            header("Pragma: no-cache");
            header("Cache-Control: no-cache");
            header("Expires: 0");

            include("db_config.php");
            include("functionclass.php");
            $ClassObject = new PHPClass();
            $token = $ClassObject->getToken();
            $token = json_decode($token);
            $authorization = "Authorization: Bearer " . $token->access_token;
            if(isset($_POST['TXNID']))
            {
                $logQuery = "SELECT * FROM information_schema.tables WHERE table_schema =  '".DBNAME."' AND table_name = 'payment_log' LIMIT 1";
                $select = mysqli_query($conn, $logQuery);

                if (mysqli_num_rows($select) > 0) 
                {
                    $sql = "SELECT * FROM payment_log where txn_id='" . $_POST['TXNID']."'";
                    $selectLog = mysqli_query($conn, $sql);
                    $result = array();
                    if (mysqli_num_rows($selectLog) == 0) 
                    {
                        $responceJson = json_encode($_POST);
                        $query = "INSERT INTO payment_log (txn_id, responce) VALUES ('" . $_POST['TXNID'] . "', '".$responceJson."')";
                        $insert = mysqli_query($conn, $query);
                    } 
                }
            }
            $academyLocationId = $_POST['ACADEMYLOCATIONID'];
            $orderId = $_POST['ORDERID'];
            $orderIdArr = explode("-", $orderId);
            $status = $_POST["STATUS"];
            $transactionId = $_POST['TXNID'];
            $onlinePaymentId = $orderIdArr[0];
            $url = baseURL . paytmGatewayDetailsAPI . '?isActive=' . IS_ACTIVE . '&academyLocationIds=' . $academyLocationId;
            // exit;
            $ch = curl_init($url);
            curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "GET");
            //  curl_setopt($ch, CURLOPT_POSTFIELDS, $applicantjson); 
            curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE);
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_TIMEOUT, 120);
            curl_setopt(
                $ch,
                CURLOPT_HTTPHEADER,
                array(
                    'Content-Type: application/json',
                    $authorization,
                )
            );

            $resultcurl = curl_exec($ch);
            $responceERPGateway = json_decode($resultcurl);
            if(isset($responceERPGateway->merchantKey))
            {
                define('PAYTM_ENVIRONMENT', $responceERPGateway->transactionURL);
                define('PAYTM_MID', $responceERPGateway->mid);
                define('PAYTM_MERCHANT_KEY', $responceERPGateway->merchantKey);  
                define('PAYTM_WEBSITE', $responceERPGateway->website);

                $checksum = (!empty($_POST['CHECKSUMHASH'])) ? $_POST['CHECKSUMHASH'] : '';
                            unset($_POST['CHECKSUMHASH']);
                unset($_POST['ACADEMYLOCATIONID']);
                $verifySignature = PaytmChecksum::verifySignature($_POST, PAYTM_MERCHANT_KEY, $checksum);
               
                if ($_POST && $verifySignature != "") 
                {
                    /*****   Check Transaction Status Check   *****/
                    $paytmParams = array();
                    $paytmParams["body"] = array(
                        "mid" => PAYTM_MID,
                        "orderId" => $orderId,
                    );
                    $checksum = PaytmChecksum::generateSignature(json_encode($paytmParams["body"], JSON_UNESCAPED_SLASHES), PAYTM_MERCHANT_KEY);
                    $paytmParams["head"] = array("signature" => $checksum);
                    $postData = json_encode($paytmParams, JSON_UNESCAPED_SLASHES);
                    $url = $responceERPGateway->transactionStatusURL;
                    $ch = curl_init($url);
                    curl_setopt($ch, CURLOPT_POST, 1);
                    curl_setopt($ch, CURLOPT_POSTFIELDS, $postData);
                    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true); 
                    curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json'));  
                    $response = curl_exec($ch);
                    $response = json_decode($response, true);
                    $status = $response['body']['resultInfo']['resultStatus'];
                    /*****   End Check Transaction Status Check   *****/
                    
                    $querySelect = "SELECT * from exam_assessment_payment where id=" . $onlinePaymentId;
                    $queryRun = mysqli_query($conn, $querySelect);
                    $fetchDataformSubmittion = mysqli_fetch_assoc($queryRun);
                    
                    if ($status == "TXN_SUCCESS" && isset($fetchDataformSubmittion['formSubmissionStatus']) && $fetchDataformSubmittion['formSubmissionStatus'] != 1) 
                    {
                        $sqlPro = "SELECT * from exam_assessment_payment_detail where examAssessmentPaymentId=" . $onlinePaymentId;
                        $selectPro = mysqli_query($conn, $sqlPro);
                        $dataPro = mysqli_fetch_assoc($selectPro);
                        $academyLocationId = $fetchDataformSubmittion['academyLocationId'];
			$examJson = '{
			    "academyLocationId": "'.$academyLocationId.'",
                            "voucherMode": "BANK",
                            "receiptType": "REGULAR",
                            "receiptNo": "",
                            "raiseBillType": "P_AND_C_FEE",
                            "receiptFor": {
                                "id": 1,
                                "value": "STUDENT"
                            },
                            "currency": {
                                "id": 1
                            },
                            "depositedCash": null,
                            "transactionDate": "' . date('Y-m-d') . '",
                            "student": {
                                "id": "' . $dataPro['studentId'] . '"
                            },
                                "narration": "NA",
                                "evaluationGroupId":"' . $dataPro['evaluationGroupId'] . '",
                                "admissionId":"' . $dataPro['admissionId'] . '",
                                "periodId":"' . $dataPro['periodId'] . '",
                            "stageName": "Assessment Group",
                            "feePlanType": "Exam",
                            "feePlanId": "' . $dataPro['feePlanRuleStageId'] . '",
                            "status": "FULLY_PENDING",
                            "receiptPaymentInstruments": [{
                                "paymentMode": {
                                    "id": 5
                                },
                                "instrumentBank": {
                                    "id": 1
                                },
                                "instrumentNo": "' . $transactionId . '",
                                "instrumentDate": "' . date('Y-m-d') . '",
                                "amount": "' . $fetchDataformSubmittion['totalAmount'] . '"
                            }]
                        }';
			echo $examJson;
                        $ch1 = curl_init(baseURL . billHeaderCreationAssessment);
                        curl_setopt($ch1, CURLOPT_CUSTOMREQUEST, "POST");
                        curl_setopt($ch1, CURLOPT_POSTFIELDS, $examJson);
                        curl_setopt($ch1, CURLOPT_TIMEOUT, 120);
                        curl_setopt($ch1, CURLOPT_FOLLOWLOCATION, TRUE);
                        curl_setopt($ch1, CURLOPT_SSL_VERIFYPEER, false);
                        curl_setopt($ch1, CURLOPT_RETURNTRANSFER, TRUE);
                        curl_setopt(
                            $ch1,
                            CURLOPT_HTTPHEADER,
                            array(
                                'Content-Type: application/json', $authorization,
                                'Content-Length: ' . strlen($examJson)
                            )
                        );

                        $resultcurl1 = curl_exec($ch1);
                        curl_close($ch1);
                        $responceERP1 = json_decode($resultcurl1);
                        if ($responceERP1 != "" && $responceERP1 != 'Array')
                        {
                            $query = "UPDATE exam_assessment_payment_detail SET billNo='" . $responceERP1 . "', receiptNo='" . $responceERP1 . "', billId='" . $responceERP1 . "', receiptId='" . $responceERP1 . "' WHERE examAssessmentPaymentId=" . $onlinePaymentId;
                            $update = mysqli_query($conn, $query);

                            $query = "UPDATE exam_assessment_payment SET paymentStatus='" . $status . "', paymentDate=curdate(), receiptStatus='" . $status . "', formSubmissionStatus = 1, txnId ='".$transactionId."'  WHERE id=" . $onlinePaymentId;
                            $update = mysqli_query($conn, $query); 

                            echo '<div class="col-md-12 alert alert-success alert-dismissible fade show text-center">
                                    <h4>Fee Payment is successful !!!.<br /><br />Thank you for the payment. Your Transaction id is <b>'.$transactionId.'.<br /> Please close the window.</h4>
                                </div>';

                        }
                        else
                        {
                            $query = "UPDATE exam_assessment_payment SET paymentStatus='" . $status . "', paymentDate=curdate(), receiptStatus='',formSubmissionStatus = 1, txnId ='".$transactionId."' WHERE id=" . $onlinePaymentId;
                            $update = mysqli_query($conn, $query);
                            echo '<div class="col-md-12 alert alert-success alert-dismissible fade show text-center"><h4>Your transaction is successful, but a receipt is not generated.<br /><br /> Please note your Transaction Id : '.$transactionId.' contact institute administrator</h4></div>';
                        }
                    }
                    else
                    {
                        if($status != "TXN_SUCCESS")
                        {
                            $query = "UPDATE exam_assessment_payment SET paymentStatus='" . $status . "', paymentDate=curdate(), receiptStatus='', txnId ='".$transactionId."',formSubmissionStatus = 1 WHERE id=" . $onlinePaymentId;
                                $update = mysqli_query($conn, $query);
                        }
                        echo '<div class="col-md-12 alert alert-warning alert-dismissible fade show text-center">
                                <h4>Unfortunately, Your transaction could not be processed. Please try again.</h4>
                            </div>';
                    }
                } 
                else 
                {
                    echo '<div class="col-md-12 alert alert-warning alert-dismissible fade show text-center">
                            <h4>Invalid Transaction. Please try again.</h4>
                        </div>';
                }
            }
            else
            {
                echo '<div class="col-md-12 alert alert-warning alert-dismissible fade show text-center">
                        <h4>Unfortunately, Your transaction could not be processed. Please try again.</h4>
                    </div>';
            }
        ?>
        <div class="col-md-12  footer-main">
          <div class="footer-text">Copyright © <?php echo date('Y'); ?> Serosoft Solutions Pvt Ltd. All Rights Reserved.
          </div>
        </div>
        <script type="text/javascript">
            setTimeout(function() {
                document.getElementById("loader").style.display = 'none'
            },1000)
        </script>
    </body>
</html>
