<!DOCTYPE html>
<html>
    <head>
        <title>Paytm Payment Gateway</title>
        <link rel="stylesheet" href="css/bootstrap.min.css" crossorigin="anonymous">
        <style type="text/css">
            .footer-main{
                position: absolute;
                bottom: 0;
                text-align: center;
                background: #dddddd42;
            }
            #loader{
              position: fixed;
              left: 0px;
              top: 0px;
              width: 100%;
              height: 100%;
              z-index: 9999;
              background: url('image/Loader.gif') 
                          50% 50% no-repeat rgb(249,249,249);
            }
        </style>
    </head>
    <body>
        <div id="loader"></div>
        <?php
            require_once "PaytmChecksum.php";
            // echo "<pre>";print_r($_POST);
            error_reporting(E_ALL);
            include('Logger.php');
            Logger::notice("Success-Revoluation-Payment");
            Logger::info(serialize($_POST));
            ob_start();
            header("Pragma: no-cache");
            header("Cache-Control: no-cache");
            header("Expires: 0");

            include("db_config.php");
            include("functionclass.php");
            $ClassObject = new PHPClass();
            $token = $ClassObject->getToken();
            $token = json_decode($token);
            $authorization = "Authorization: Bearer " . $token->access_token;
            if(isset($_POST['TXNID']))
            {
                $logQuery = "SELECT * FROM information_schema.tables WHERE table_schema =  '".DBNAME."' AND table_name = 'payment_log' LIMIT 1";
                $select = mysqli_query($conn, $logQuery);

                if (mysqli_num_rows($select) > 0) 
                {
                    $sql = "SELECT * FROM payment_log where txn_id='" . $_POST['TXNID']."'";
                    $selectLog = mysqli_query($conn, $sql);
                    $result = array();
                    if (mysqli_num_rows($selectLog) == 0) 
                    {
                        $responceJson = json_encode($_POST);
                        $query = "INSERT INTO payment_log (txn_id, responce) VALUES ('" . $_POST['TXNID'] . "', '".$responceJson."')";
                        $insert = mysqli_query($conn, $query);
                    } 
                }
            }
            $academyLocationId = $_POST['ACADEMYLOCATIONID'];
            $orderId = $_POST['ORDERID'];
            $orderIdArr = explode("-", $orderId);
            $status = $_POST["STATUS"];
            $transactionId = $_POST['TXNID'];
            $onlinePaymentId = $orderIdArr[0];
            $url = baseURL . paytmGatewayDetailsAPI . '?isActive=' . IS_ACTIVE . '&academyLocationIds=' . $academyLocationId;
            // exit;
            $ch = curl_init($url);
            curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "GET");
            //  curl_setopt($ch, CURLOPT_POSTFIELDS, $applicantjson); 
            curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE);
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_TIMEOUT, 120);
            curl_setopt(
                $ch,
                CURLOPT_HTTPHEADER,
                array(
                    'Content-Type: application/json',
                    $authorization,
                )
            );

            $resultcurl = curl_exec($ch);
            $responceERPGateway = json_decode($resultcurl);
            if(isset($responceERPGateway->merchantKey))
            {
                define('PAYTM_ENVIRONMENT', $responceERPGateway->transactionURL);
                define('PAYTM_MID', $responceERPGateway->mid);
                define('PAYTM_MERCHANT_KEY', $responceERPGateway->merchantKey);  
                define('PAYTM_WEBSITE', $responceERPGateway->website);

                $checksum = (!empty($_POST['CHECKSUMHASH'])) ? $_POST['CHECKSUMHASH'] : '';
                            unset($_POST['CHECKSUMHASH']);
                unset($_POST['ACADEMYLOCATIONID']);
                $verifySignature = PaytmChecksum::verifySignature($_POST, PAYTM_MERCHANT_KEY, $checksum);
               
                if ($_POST && $verifySignature != "") 
                {
                    $id = $onlinePaymentId;
                    $querySelect = "SELECT * from exam_reval_payment where id=" . $id;
                    $queryRun = mysqli_query($conn, $querySelect);
                    $fetchData = mysqli_fetch_assoc($queryRun);

                    if ($status == "TXN_SUCCESS" && isset($fetchData['formSubmissionStatus']) && $fetchData['formSubmissionStatus'] != 1) 
                    {
                        $query = "UPDATE exam_reval_payment SET paymentStatus='" . $status . "',paymentDate=curdate(), receiptStatus='', txnId='" . $transactionId . "', formSubmissionStatus=1 WHERE id=" . $id;
                        $update = mysqli_query($conn, $query);

                         $sqlPro = "SELECT * from exam_reval_payment_detail where examRevalPaymentId=" . $id;
                        $selectPro = mysqli_query($conn, $sqlPro);
                        $resultCom = array();
                        while ($dataPro = mysqli_fetch_assoc($selectPro))
                        {
                            $fetchDataDetail[] = $dataPro;
                        }
                        $examjsonPro = "";

                        /*---------------------------------------Program Json-------------------------------*/
                        $examjsonProgram = '[';
                        foreach ($fetchDataDetail as $key => $resultProData) 
                        {
                            $examRevalPayment = '{
                                        "id":' . $resultProData['examRevalPaymentId'] . '
                                    }';
                            $examjsonPro1 = '{
                                    "id": ' . $resultProData['id'] . ',
                                    "examRevalPayment":' . $examRevalPayment . ',
                                    "admissionId": ' . $resultProData['admissionId'] . ',
                                    "studentId": ' . $resultProData['studentId'] . ',
                                    "feePlanRuleStageId":' . $resultProData['feePlanRuleStageId'] . ',
                                    "amount": ' . $resultProData['amount'] . ',
                                    "examRevalRuleMappingId": ' . $resultProData['examRevalRuleMappingId'] . ',
                                    "examinationResultId": ' . $resultProData['examinationResultId'] . ',
                                    "courseVariantId": ' . $resultProData['courseVariantId'] . ',
                                    "periodId": ' . $resultProData['periodId'] . ',
                                    "eventId": ' . $resultProData['eventId'] . ',
                                    "revaluationType": "' . $resultProData['revaluationType'] . '",
                                    "appliedDate": "' . $resultProData['appliedDate'] . '",
                                    "previousMarks": ' . $resultProData['previousMarks'] . ',
                                    "previousGrade": "' . $resultProData['previousGrade'] . '",
                                    "previousGradePoint": ' . $resultProData['previousGradePoint'] . ',
                                    "previousResultStatus": "' . $resultProData['previousResultStatus'] . '"
                                    },';
                            $examjsonPro .= $examjsonPro1;
                        }
                        $examjsonPro = rtrim($examjsonPro, ',');
                        $examjsonPro .= ']';
                        $examjsonProgram .= $examjsonPro;
                        /*-------------------------------------------------------------------------*/

                        $examJson = ' {
                                        "id": ' . $resultProData['id'] . ',
                                        "totalAmount":  ' . $fetchData['totalAmount'] . ',
                                        "txnId":  "' . $transactionId . '",
                                        "detailModel":' . $examjsonProgram . '
                                    }';
                        $ch1 = curl_init(baseURL . billHeaderCreation);
                        curl_setopt($ch1, CURLOPT_CUSTOMREQUEST, "POST");
                        curl_setopt($ch1, CURLOPT_POSTFIELDS, $examJson);
                        curl_setopt($ch1, CURLOPT_TIMEOUT, 120);
                        curl_setopt($ch1, CURLOPT_FOLLOWLOCATION, TRUE);
                        curl_setopt($ch1, CURLOPT_SSL_VERIFYPEER, false);
                        curl_setopt($ch1, CURLOPT_RETURNTRANSFER, TRUE);
                        curl_setopt(
                            $ch1,
                            CURLOPT_HTTPHEADER,
                            array(
                                'Content-Type: application/json', $authorization,
                                'Content-Length: ' . strlen($examJson)
                            )
                        );

                        $resultcurl1 = curl_exec($ch1);
                        curl_close($ch1);
                        $responceERP1 = json_decode($resultcurl1);

                        if (isset($responceERP1->receiptStatus) && $responceERP1->receiptStatus == '1') 
                        {
                            foreach ($responceERP1->detailModel as $examDetailModelData) 
                            {
                                $query = "UPDATE exam_reval_payment_detail SET billNo='" . $examDetailModelData->billNo . "', receiptNo='" . $examDetailModelData->receiptNo . "', billId='" . $examDetailModelData->billId . "', receiptId='" . $examDetailModelData->receiptId . "' WHERE id=" . $examDetailModelData->id;
                                $update = mysqli_query($conn, $query);
                            }

                            $query = "UPDATE exam_reval_payment SET paymentStatus='" . $status . "', paymentDate=curdate(), receiptStatus='" . $responceERP1->receiptStatus . "' WHERE id=" . $id;
                            $update = mysqli_query($conn, $query);

                            echo '<div class="col-md-12 alert alert-success alert-dismissible fade show text-center">
                                    <h4>Fee Payment is successful !!!.<br /><br />Thank you for the payment. Your Transaction id is <b>'.$transactionId.'</b> and Receipt Number : <b>'.$examDetailModelData->receiptNo.'</b>.<br /> Please close the window.</h4>
                                </div>';
                        } 
                        else 
                        {
                            
                            echo '<div class="col-md-12 alert alert-success alert-dismissible fade show text-center">
                                    <h4>Your transaction is successful, but a receipt is not generated.<br /><br /> Please note your Transaction Id '.$transactionId.' and contact institute administrator</h4>
                                </div>';
                            
                        }
                    }
                    else
                    {
                        if($status != "TXN_SUCCESS")
                        {
                            $query = "UPDATE exam_reval_payment SET paymentStatus='" . $status . "',paymentDate=curdate(), receiptStatus='', txnId='" . $transactionId . "', formSubmissionStatus=1 WHERE id=" . $id;
                            $update = mysqli_query($conn, $query);
                        }
                        echo '<div class="col-md-12 alert alert-warning alert-dismissible fade show text-center">
                                <h4>Unfortunately, Your transaction could not be processed. Please try again.</h4>
                            </div>';
                    }
                } 
                else 
                {
                    echo '<div class="col-md-12 alert alert-warning alert-dismissible fade show text-center">
                            <h4>Invalid Transaction. Please try again.</h4>
                        </div>';
                }
            }
            else
            {
                echo '<div class="col-md-12 alert alert-warning alert-dismissible fade show text-center">
                        <h4>Unfortunately, Your transaction could not be processed. Please try again.</h4>
                    </div>';
            }
        ?>
        <div class="col-md-12  footer-main">
          <div class="footer-text">Copyright © <?php echo date('Y'); ?> Serosoft Solutions Pvt Ltd. All Rights Reserved.
          </div>
        </div>
        <script type="text/javascript">
            setTimeout(function() {
                document.getElementById("loader").style.display = 'none'
            },1000);
        </script>
    </body>
</html>