<?php
header("Pragma: no-cache");
header("Cache-Control: no-cache");
header("Expires: 0");

// following files need to be included
require_once("./lib/config_paytm.php");
require_once("./lib/encdec_paytm.php");

$checkSum = "";

// below code snippet is mandatory, so that no one can use your checksumgeneration url for other purpose .
// $findme   = 'REFUND';
$findme   = 'REFUND';
$findmepipe = '|';

$paramList = array();

$paramList["MID"] = '';
$paramList["ORDER_ID"] = '';
$paramList["CUST_ID"] = '';
$paramList["INDUSTRY_TYPE_ID"] = '';
$paramList["CHANNEL_ID"] = '';
$paramList["TXN_AMOUNT"] = '';
$paramList["WEBSITE"] = '';
$paramList["CALLBACK_URL"] = '';
// $paramList["MOBILE_NO"] = '';
// $paramList["EMAIL"] = '';

foreach ($_REQUEST as $key => $value) {
  $pos = strpos($value, $findme);
  $pospipe = strpos($value, $findmepipe);
  if ($pos === false || $pospipe === false) {
    $paramList[$key] = $value;
  }
}
$logRequest = $paramList;
$logRequest['PAYTM_MERCHANT_KEY'] = PAYTM_MERCHANT_KEY;
include('Logger.php');
Logger::notice("Mobile-App-Request");
Logger::info(serialize($logRequest));


unset($paramList['env']);
unset($paramList['isActive']);
unset($paramList['academyLocationIds']);
// echo PAYTM_MERCHANT_KEY;
// print_r($paramList);exit;
//Here checksum string will return by getChecksumFromArray() function.
$checkSum = getChecksumFromArray($paramList, PAYTM_MERCHANT_KEY);
//print_r($_POST);
echo json_encode(array("CHECKSUMHASH" => $checkSum, "ORDER_ID" => $_REQUEST["ORDER_ID"], "payt_STATUS" => "1", 'PAYTM_MERCHANT_KEY' => PAYTM_MERCHANT_KEY, 'payload' => $paramList), JSON_UNESCAPED_SLASHES);
  //Sample response return to SDK
 
//  {"CHECKSUMHASH":"GhAJV057opOCD3KJuVWesQ9pUxMtyUGLPAiIRtkEQXBeSws2hYvxaj7jRn33rTYGRLx2TosFkgReyCslu4OUj\/A85AvNC6E4wUP+CZnrBGM=","ORDER_ID":"asgasfgasfsdfhl7","payt_STATUS":"1"}
// https://sangamuniversity.academiaerp.com/paytm_app/generateChecksum.php?env=LIVE&isActive=true&academyLocationIds=1&MID=Sangam78853962080184&ORDER_ID=SerosoftOrder1644&CUST_ID=2019SUBSAG025_Manish_Acharya_abc@gmail.com_android&INDUSTRY_TYPE_ID=PrivateEducation&CHANNEL_ID=WAP&TXN_AMOUNT=50&WEBSITE=WEBPROD&CALLBACK_URL=https://securegw.paytm.in/theia/paytmCallback?ORDER_ID=SerosoftOrder1644